/***** Autogenerated from runtime.in; changes will be overwritten *****/

#line 1 "runtime.in"
/*****
 * runtime.in
 * Tom Prince 2005/4/15
 *
 * Generate the runtime functions used by the vm::stack machine.
 *
 *****/

/* Autogenerated routines are specified like this (separated by a formfeed):
type asyname:cname(cparams)
{
  C code
}
*/


#line 49 "runtime.in"
#include <cfloat>
#include "angle.h"
#include "pair.h"
#include "triple.h"
#include "transform.h"
#include "path.h"
#include "pen.h"
#include "guide.h"
#include "picture.h"
#include "drawpath.h"
#include "drawfill.h"
#include "drawclipbegin.h"
#include "drawclipend.h"
#include "drawlabel.h"
#include "drawverbatim.h"
#include "drawgsave.h"
#include "drawgrestore.h"
#include "drawlayer.h"
#include "drawimage.h"
#include "drawgroup.h"
#include "fileio.h"
#include "genv.h"
#include "builtin.h"
#include "texfile.h"
#include "pipestream.h"
#include "parser.h"
#include "stack.h"
#include "util.h"
#include "mathop.h"
#include "callable.h"
#include "stm.h"
  
#ifdef HAVE_LIBFFTW3
#include "fftw++.h"
#endif
  
#if defined(HAVE_LIBREADLINE) && defined(HAVE_LIBCURSES)
#include <readline/readline.h>
#include <readline/history.h>
#endif

using namespace vm;
using namespace camp;
using namespace settings;

namespace settings {
extern pen *initialdefaultpen;
}

namespace run {
using camp::pair;
using mem::string;
using vm::array;
using vm::frame;
using vm::stack;
using camp::transform;
using absyntax::runnable;

callable *atExitFunction=NULL;
callable *atDrawFunction=NULL;
  
typedef double real;

typedef array boolarray;
typedef array intarray;
typedef array realarray;
typedef array realarray2;
typedef array pairarray;
typedef array triplearray;
typedef array patharray;
typedef array guidearray;
typedef array transformarray;
typedef array penarray;
typedef array penarray2;
typedef array stringarray;
typedef array stringarray2;
}

using vm::array;
using types::function;
using types::primVoid;
using types::primBoolean;
using types::primInt;
using types::primReal;
using types::primPair;
using types::primTriple;
using types::primPen;
using types::primPath;
using types::primGuide;
using types::primPicture;
using types::primString;
using types::primCode;
using types::primArray;
using types::primFile;
using types::primTransform;
using types::boolArray;
using types::intArray;
using types::realArray;
using types::realArray2;
using types::pairArray;
using types::tripleArray;
using types::pathArray;
using types::guideArray;
using types::transformArray;
using types::penArray;
using types::penArray2;
using types::stringArray;
using types::stringArray2;
using types::formal;

namespace loop {
  void doIRunnable(absyntax::runnable *r, bool embedded=false);
  void doITree(absyntax::block *tree, bool embedded=false);
}
  
function *voidFunction()
{
  return new function(primVoid());
}

const int camp::ColorComponents[]={0,0,1,3,4,0};

namespace vm {
const char *arraymismatch="operation attempted on arrays of different lengths";
}

namespace run {
  
const char *arraymin="cannot take min of empty array";
const char *arraymax="cannot take max of empty array";

static inline int Round(double x) 
{
  return int(x+((x >= 0) ? 0.5 : -0.5));
}

inline int sgn(double x) 
{
  return (x > 0.0 ? 1 : (x < 0.0 ? -1 : 0));
}

void outOfBounds(const char *op, size_t len, int n)
{
  ostringstream buf;
  buf << op << " array of length " << len << " with out-of-bounds index "
      << n;
  error(buf);
}

inline item& arrayRead(array *a, int n)  
{
  size_t len=checkArray(a);
  bool cyclic=a->cyclic();
  if(cyclic && len > 0) n=imod(n,len);
  else if(n < 0 || n >= (int) len) outOfBounds("reading",len,n);
  return (*a)[(unsigned) n];
}

// Helper function to create deep arrays.
static array* deepArray(int depth, int *dims)
{
  assert(depth > 0);
  
  if (depth == 1) {
    return new array(dims[0]);
  } else {
    int length = dims[0];
    depth--; dims++;

    array *a = new array(length);

    for (int index = 0; index < length; index++) {
      (*a)[index] = deepArray(depth, dims);
    }
    return a;
  }
}
  
array *copyArray(array *a)
{
  size_t size=checkArray(a);
  array *c=new array(size);
  for(size_t i=0; i < size; i++) 
    (*c)[i]=(*a)[i];
  return c;
}

array *copyArray2(array *a)
{
  size_t size=checkArray(a);
  array *c=new array(size);
  for(size_t i=0; i < size; i++) {
    array *ai=read<array*>(a,i);
    size_t aisize=checkArray(ai);
    array *ci=new array(aisize);
    (*c)[i]=ci;
    for(size_t j=0; j < aisize; j++) 
      (*ci)[j]=(*ai)[j];
  }
  return c;
}

void writestring(stack *s)
{
  callable *suffix=pop<callable *>(s,NULL);
  string S=pop<string>(s);
  vm::item it=pop(s);
  bool defaultfile=isdefault(it);
  camp::file *f=defaultfile ? &camp::Stdout : vm::get<camp::file*>(it);
  if(!f->isOpen()) return;
  if(S != "") f->write(S);
  if(f->text()) {
    if(suffix) {
      s->push(f);
      suffix->call(s);
    } else if(defaultfile) f->writeline();
  }
}

void dividebyzero(size_t i)
{
  std::ostringstream buf;
  if(i > 0) buf << "array element " << i << ": ";
  buf << "Divide by zero";
  error(buf);
}
  
void integeroverflow(size_t i)
{
  std::ostringstream buf;
  if(i > 0) buf << "array element " << i << ": ";
  buf << "Integer overflow";
  error(buf);
}
  
#if defined(HAVE_LIBREADLINE) && defined(HAVE_HISTORY_STATE) && \
    defined(HAVE_LIBCURSES)
typedef mem::map<CONST string, HISTORY_STATE> historyMap_t;
historyMap_t historyMap;
static HISTORY_STATE history_save;

// Store a deep copy of the current readline history in dest.
void store_history(HISTORY_STATE *dest)
{
  HISTORY_STATE *src=history_get_history_state();
  *dest=*src;
  if(src) {
    for(int i=0; i < src->length; ++i)
      dest->entries[i]=src->entries[i];
    free(src);
  }
}

const char nosave='\n';

string historyfilename(const string &name) 
{
  return historyname+"_"+name;
}
#endif

#if defined(HAVE_LIBREADLINE) && defined(HAVE_LIBCURSES)
int readline_startup_hook()
{
#ifdef __CYGWIN__
  rl_set_key("\\M-[3~",rl_delete,rl_get_keymap());
  rl_set_key("\\M-[2~",rl_overwrite_mode,rl_get_keymap());
#endif    
  return 0;
}

void init_readline(bool tabcompletion=true) 
{
  static bool first=true;
  if(first) {
    first=false;
#ifdef __CYGWIN__
    rl_startup_hook=readline_startup_hook;
#endif    
  }
  rl_bind_key('\t',tabcompletion ? rl_complete : rl_insert);
}
#endif

static size_t *pivot,*Row,*Col;
static inline void solveAllocate(size_t n, size_t m)
{
  pivot=new size_t[n];
  if(m == 0) {
    Row=new size_t[n];
    Col=new size_t[n];
  } else {
    Row=NULL;
    Col=NULL;
  }
}

static inline void solveDeallocate()
{
  delete[] pivot;
  if(Row) delete[] Row;
  if(Col) delete[] Col;
}

void clearTeX()
{
  if(TeXinitialized) {
    camp::TeXpipepreamble.clear();
    camp::TeXpreamble.clear();
    camp::tex.pipeclose();
    TeXinitialized=false;
  }
}

void cleanup()
{
  if(initialdefaultpen) defaultpen=*initialdefaultpen;
  if(!interact::interactive) scrollLines=0;
  
  clearTeX();

#if defined(HAVE_LIBREADLINE) && defined(HAVE_HISTORY_STATE) && \
    defined(HAVE_LIBCURSES)
  store_history(&history_save);
  int nlines=getSetting<int>("historylines");
  for(historyMap_t::iterator h=historyMap.begin(); h != historyMap.end(); 
      ++h) {
    history_set_history_state(&h->second);
    stifle_history(nlines);
    if(h->first[0] != nosave) write_history(historyfilename(h->first).c_str());
  }
  history_set_history_state(&history_save);
#endif
}

void exitFunction(stack *Stack)
{
  if(atExitFunction && !nullfunc::instance()->compare(atExitFunction)) {
    atExitFunction->call(Stack);
    atExitFunction=NULL;
  }
  cleanup();
}

void updateFunction(stack *Stack)
{
  if(atExitFunction && !nullfunc::instance()->compare(atExitFunction))
    atExitFunction->call(Stack);
}

default_t def;
string emptystring;
transform Identity;
string commentchar="#";

}

namespace types {
extern const char *names[];
}

void checkformat(const char *ptr, bool intformat) 
{
  while(*ptr != '\0') {
    if(*ptr != '%') /* While we have regular characters, print them.  */
      ptr++;
    else { /* We've got a format specifier. */
      ptr++;
      
      while(*ptr && strchr ("-+ #0'I", *ptr)) /* Move past flags.  */
	*ptr++;

      if(*ptr == '*')
	ptr++;
      else while(isdigit(*ptr)) /* Handle explicit numeric value.  */
	ptr++;
	  
      if(*ptr == '.') {
	*ptr++; /* Go past the period.  */
	if(*ptr == '*') {
	  ptr++;
	} else
	  while(isdigit(*ptr)) /* Handle explicit numeric value.  */
	    *ptr++;
      }
      while(*ptr && strchr ("hlL", *ptr))
	*ptr++;
	  
      if(*ptr == '%') ++ptr;
      else if(*ptr != '\0') {
	if(intformat) {
	  switch(*ptr) {
	  case 'd':
	  case 'i':
	  case 'o':
	  case 'u':
	  case 'x':
	  case 'X':
	  case 'c':
	    break;
	  default:
	    ostringstream buf;
	    buf << "Invalid format '" << *ptr << "' for type " 
		<< types::names[types::ty_int];
	    error(buf);
	    break;
	  }
	} else {
	  switch(*ptr) {
	  case 'f':
	  case 'F':
	  case 'e':
	  case 'E':
	  case 'g':
	  case 'G':
	    break;
	  default:
	    ostringstream buf;
	    buf << "Invalid format '" << *ptr << "' for type "
		<< types::names[types::ty_real];
	    error(buf);
	    break;
	  }
	}
      }
    } /* End of else statement */
  }
}
  
// Return an angle in the interval [0,360).
inline double principalBranch(double deg)
{
  if(deg < 0) deg += 360; 
  return deg;
}

inline double Min(double a, double b)
{
  return (a < b) ? a : b;
}

inline double Max(double a, double b)
{
  return (a > b) ? a : b;
}

// Auto-generated routines:



namespace run {

// Initializers
#line 500 "runtime.in"
void intZero(stack *Stack)
{
#line 501 "runtime.in"
  {Stack->push<int>(0); return;}
}

#line 506 "runtime.in"
void realZero(stack *Stack)
{
#line 507 "runtime.in"
  {Stack->push<real>(0.0); return;}
}

#line 511 "runtime.in"
void boolFalse(stack *Stack)
{
#line 512 "runtime.in"
  {Stack->push<bool>(false); return;}
}

#line 516 "runtime.in"
void pushNullArray(stack *Stack)
{
#line 517 "runtime.in"
  {Stack->push<array*>(0); return;}
}

#line 521 "runtime.in"
void pushNullRecord(stack *Stack)
{
#line 522 "runtime.in"
  {Stack->push<frame*>(0); return;}
}

#line 526 "runtime.in"
void pushNullFunction(stack *Stack)
{
#line 527 "runtime.in"
  {Stack->push(nullfunc::instance()); return;}
}


// Default operations

// Put the default value token on the stack (in place of an argument when
// making a function call).
#line 536 "runtime.in"
void pushDefault(stack *Stack)
{
#line 537 "runtime.in"
  {Stack->push(def); return;}
}


// Test if the value on the stack is the default value token.
#line 543 "runtime.in"
void isDefault(stack *Stack)
{
  item i = vm::pop(Stack);
#line 544 "runtime.in"
  {Stack->push<bool>(isdefault(i)); return;}
}


// Logical operations
#line 550 "runtime.in"
// bool !(bool b);
void gen8(stack *Stack)
{
  bool b = vm::pop<bool>(Stack);
#line 551 "runtime.in"
  {Stack->push<bool>(!b); return;}
}

#line 556 "runtime.in"
void boolMemEq(stack *Stack)
{
  frame * b = vm::pop<frame *>(Stack);
  frame * a = vm::pop<frame *>(Stack);
#line 557 "runtime.in"
  {Stack->push<bool>(a == b); return;}
}

#line 561 "runtime.in"
void boolMemNeq(stack *Stack)
{
  frame * b = vm::pop<frame *>(Stack);
  frame * a = vm::pop<frame *>(Stack);
#line 562 "runtime.in"
  {Stack->push<bool>(a != b); return;}
}

#line 566 "runtime.in"
void boolFuncEq(stack *Stack)
{
  callable * b = vm::pop<callable *>(Stack);
  callable * a = vm::pop<callable *>(Stack);
#line 567 "runtime.in"
  {Stack->push<bool>(a->compare(b)); return;}
}

#line 571 "runtime.in"
void boolFuncNeq(stack *Stack)
{
  callable * b = vm::pop<callable *>(Stack);
  callable * a = vm::pop<callable *>(Stack);
#line 572 "runtime.in"
  {Stack->push<bool>(!(a->compare(b))); return;}
}


// Casts
#line 578 "runtime.in"
void pairToGuide(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 579 "runtime.in"
  {Stack->push<guide*>(new pairguide(z)); return;}
}

#line 584 "runtime.in"
void pathToGuide(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 585 "runtime.in"
  {Stack->push<guide*>(new pathguide(p)); return;}
}

#line 589 "runtime.in"
void guideToPath(stack *Stack)
{
  guide * g = vm::pop<guide *>(Stack);
#line 590 "runtime.in"
  {Stack->push<path>(g->solve()); return;}
}


// Picture operations
#line 596 "runtime.in"
void newPicture(stack *Stack)
{
#line 597 "runtime.in"
  {Stack->push<picture*>(new picture()); return;}
}

#line 602 "runtime.in"
// bool empty(picture *f);
void gen17(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 603 "runtime.in"
  {Stack->push<bool>(f->null()); return;}
}

#line 607 "runtime.in"
// pair max(picture *f);
void gen18(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 608 "runtime.in"
  {Stack->push<pair>(f->bounds().Max()); return;}
}

#line 612 "runtime.in"
// pair min(picture *f);
void gen19(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 613 "runtime.in"
  {Stack->push<pair>(f->bounds().Min()); return;}
}

#line 617 "runtime.in"
// void label(picture *f, string *s, string *size, real angle, pair position,	   pair align, pair scale, pen p);
void gen20(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  pair scale = vm::pop<pair>(Stack);
  pair align = vm::pop<pair>(Stack);
  pair position = vm::pop<pair>(Stack);
  real angle = vm::pop<real>(Stack);
  string * size = vm::pop<string *>(Stack);
  string * s = vm::pop<string *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 619 "runtime.in"
  f->append(new drawLabel(*s,*size,angle,position,align,scale,p));
}

#line 623 "runtime.in"
// bool labels(picture *f);
void gen21(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 624 "runtime.in"
  {Stack->push<bool>(f->havelabels()); return;}
}

#line 628 "runtime.in"
// void fill(picture *f, patharray *g, pen p);
void gen22(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 629 "runtime.in"
  f->append(new drawFill(copyArray(g),p));
}

#line 633 "runtime.in"
// void latticeshade(picture *f, patharray *g, pen fillrule, penarray2 *p);
void gen23(stack *Stack)
{
  penarray2 * p = vm::pop<penarray2 *>(Stack);
  pen fillrule = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 634 "runtime.in"
  f->append(new drawLatticeShade(copyArray(g),fillrule,copyArray(p)));
}

#line 638 "runtime.in"
// void axialshade(picture *f, patharray *g, pen pena, pair a, pen penb, pair b);
void gen24(stack *Stack)
{
  pair b = vm::pop<pair>(Stack);
  pen penb = vm::pop<pen>(Stack);
  pair a = vm::pop<pair>(Stack);
  pen pena = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 639 "runtime.in"
  f->append(new drawAxialShade(copyArray(g),pena,a,penb,b));
}

#line 643 "runtime.in"
// void radialshade(picture *f, patharray *g, pen pena, pair a, real ra,		 pen penb, pair b, real rb);
void gen25(stack *Stack)
{
  real rb = vm::pop<real>(Stack);
  pair b = vm::pop<pair>(Stack);
  pen penb = vm::pop<pen>(Stack);
  real ra = vm::pop<real>(Stack);
  pair a = vm::pop<pair>(Stack);
  pen pena = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 645 "runtime.in"
  f->append(new drawRadialShade(copyArray(g),pena,a,ra,penb,b,rb));
}

#line 649 "runtime.in"
// void gouraudshade(picture *f, patharray *g, pen fillrule, penarray *p,		  pairarray *z, intarray *edges);
void gen26(stack *Stack)
{
  intarray * edges = vm::pop<intarray *>(Stack);
  pairarray * z = vm::pop<pairarray *>(Stack);
  penarray * p = vm::pop<penarray *>(Stack);
  pen fillrule = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 651 "runtime.in"
  checkArrays(p,z);
  checkArrays(z,edges);
  f->append(new drawGouraudShade(copyArray(g),fillrule,copyArray(p),
				 copyArray(z),copyArray(edges)));
}

// Clip a picture to a superpath using the given fill rule.
// Subsequent additions to the picture will not be affected by the clipping.
#line 660 "runtime.in"
// void clip(picture *f, patharray *g, pen p);
void gen27(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 661 "runtime.in"
  f->enclose(new drawClipBegin(copyArray(g),p),new drawClipEnd());
}

#line 665 "runtime.in"
// void beginclip(picture *f, patharray *g, pen p);
void gen28(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 666 "runtime.in"
  f->append(new drawClipBegin(copyArray(g),p,false));
}

#line 670 "runtime.in"
// void postscript(picture *f, string s);
void gen29(stack *Stack)
{
  string s = vm::pop<string>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 671 "runtime.in"
  f->append(new drawVerbatim(PostScript,s));
}

#line 675 "runtime.in"
// void tex(picture *f, string s);
void gen30(stack *Stack)
{
  string s = vm::pop<string>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 676 "runtime.in"
  f->append(new drawVerbatim(TeX,s));
}

#line 680 "runtime.in"
// void texpreamble(string s);
void gen31(stack *Stack)
{
  string s = vm::pop<string>(Stack);
#line 681 "runtime.in"
  string t=s+"\n";
  camp::TeXpipepreamble.push_back(t);
  camp::TeXpreamble.push_back(t);
}

#line 687 "runtime.in"
// void texreset();
void gen32(stack *)
{
#line 688 "runtime.in"
  clearTeX();
}

#line 692 "runtime.in"
// void layer(picture *f);
void gen33(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 693 "runtime.in"
  f->append(new drawLayer());
}

#line 697 "runtime.in"
// void image(picture *f, realarray2 *data, penarray *palette, 	   pair initial, pair final, transform t=Identity);
void gen34(stack *Stack)
{
  transform t = vm::pop<transform>(Stack,Identity);
  pair final = vm::pop<pair>(Stack);
  pair initial = vm::pop<pair>(Stack);
  penarray * palette = vm::pop<penarray *>(Stack);
  realarray2 * data = vm::pop<realarray2 *>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 699 "runtime.in"
  f->append(new drawImage(copyArray2(data),copyArray(palette),
			  t*matrix(initial,final)));
}

#line 704 "runtime.in"
// void shipout(string prefix=emptystring, picture *f, picture *preamble=NULL,	     string format=emptystring, bool wait=0, bool quiet=0,	     transformarray *GUItransform, boolarray *GUIdelete);
void gen35(stack *Stack)
{
  boolarray * GUIdelete = vm::pop<boolarray *>(Stack);
  transformarray * GUItransform = vm::pop<transformarray *>(Stack);
  bool quiet = vm::pop<bool>(Stack,0);
  bool wait = vm::pop<bool>(Stack,0);
  string format = vm::pop<string>(Stack,emptystring);
  picture * preamble = vm::pop<picture *>(Stack,NULL);
  picture * f = vm::pop<picture *>(Stack);
  string prefix = vm::pop<string>(Stack,emptystring);
#line 707 "runtime.in"
  if(prefix.empty()) prefix=getSetting<string>("outname");
  
  size_t size=GUItransform && GUIdelete ?
    checkArrays(GUItransform,GUIdelete) : 0;
 
  if(getSetting<real>("deconstruct") || size) {
    picture *result=new picture;
    unsigned level=0;
    unsigned i=0;
    nodelist::iterator p;
    for(p = f->nodes.begin(); p != f->nodes.end(); ++p) {
      bool Delete;
      transform t;
      if(i < size) {
	t=*(read<transform*>(GUItransform,i));
	Delete=read<bool>(GUIdelete,i);
      } else {
	t=identity();
	Delete=false;
      }
      picture *group=new picture;
// Ignore unclosed begingroups but not spurious endgroups.
      const char *nobegin="endgroup without matching begingroup";
      assert(*p);
      if((*p)->endgroup()) error(nobegin);
      if((*p)->begingroup()) {
	++level;
	while(p != f->nodes.end() && level) {
	  drawElement *e=t.isIdentity() ? *p : (*p)->transformed(t);
	  group->append(e);
	  ++p;
	  if(p == f->nodes.end()) break;
	  assert(*p);
	  if((*p)->begingroup()) ++level;
	  if((*p)->endgroup()) if(level) --level;
	  else error(nobegin);
	}
      }
      if(p == f->nodes.end()) break;
      assert(*p);
      drawElement *e=t.isIdentity() ? *p : (*p)->transformed(t);
      group->append(e);
      if(!group->empty()) {
	if(getSetting<real>("deconstruct")) {
	  ostringstream buf;
	  buf << prefix << "_" << i;
	  group->shipout(preamble,buf.str(),"tgif",false,true,Delete);
	}
	++i;
      }
      if(size && !Delete) result->add(*group);
    }
    if(size) f=result;
  }

  f->shipout(preamble,prefix,format,wait,quiet);
}


// Pen operations
#line 768 "runtime.in"
void newPen(stack *Stack)
{
#line 769 "runtime.in"
  {Stack->push<pen>(pen()); return;}
}

#line 774 "runtime.in"
// bool ==(pen a, pen b);
void gen37(stack *Stack)
{
  pen b = vm::pop<pen>(Stack);
  pen a = vm::pop<pen>(Stack);
#line 775 "runtime.in"
  {Stack->push<bool>(a == b); return;}
}

#line 779 "runtime.in"
// bool !=(pen a, pen b);
void gen38(stack *Stack)
{
  pen b = vm::pop<pen>(Stack);
  pen a = vm::pop<pen>(Stack);
#line 780 "runtime.in"
  {Stack->push<bool>(a != b); return;}
}

#line 784 "runtime.in"
// pen +(pen a, pen b);
void gen39(stack *Stack)
{
  pen b = vm::pop<pen>(Stack);
  pen a = vm::pop<pen>(Stack);
#line 785 "runtime.in"
  {Stack->push<pen>(a+b); return;}
}

#line 789 "runtime.in"
// pen *(real a, pen b);
void gen40(stack *Stack)
{
  pen b = vm::pop<pen>(Stack);
  real a = vm::pop<real>(Stack);
#line 790 "runtime.in"
  {Stack->push<pen>(a*b); return;}
}

#line 794 "runtime.in"
// pen *(pen a, real b);
void gen41(stack *Stack)
{
  real b = vm::pop<real>(Stack);
  pen a = vm::pop<pen>(Stack);
#line 795 "runtime.in"
  {Stack->push<pen>(b*a); return;}
}

#line 799 "runtime.in"
// pair max(pen p);
void gen42(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 800 "runtime.in"
  {Stack->push<pair>(p.bounds().Max()); return;}
}

#line 804 "runtime.in"
// pair min(pen p);
void gen43(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 805 "runtime.in"
  {Stack->push<pair>(p.bounds().Min()); return;}
}

// Reset the meaning of pen default attributes.
#line 810 "runtime.in"
// void resetdefaultpen();
void gen44(stack *)
{
#line 811 "runtime.in"
  if(initialdefaultpen) defaultpen=*initialdefaultpen;
}

#line 815 "runtime.in"
// void defaultpen(pen p);
void gen45(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 816 "runtime.in"
  defaultpen=pen(resolvepen,p);
}

#line 820 "runtime.in"
// pen defaultpen();
void gen46(stack *Stack)
{
#line 821 "runtime.in"
  {Stack->push<pen>(defaultpen); return;}
}

#line 825 "runtime.in"
// pen invisible();
void gen47(stack *Stack)
{
#line 826 "runtime.in"
  {Stack->push<pen>(pen(invisiblepen)); return;}
}

#line 830 "runtime.in"
// pen gray(pen p);
void gen48(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 831 "runtime.in"
  if(p.rgb()) p.rgbtogrey();
  else if (p.cmyk()) p.cmyktogrey();
  {Stack->push<pen>(p); return;}
}

#line 837 "runtime.in"
// pen rgb(pen p);
void gen49(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 838 "runtime.in"
  if(p.grayscale()) p.greytorgb();
  else if (p.cmyk()) p.cmyktorgb();
  {Stack->push<pen>(p); return;}
}

#line 844 "runtime.in"
// pen rgb(real r, real g, real b);
void gen50(stack *Stack)
{
  real b = vm::pop<real>(Stack);
  real g = vm::pop<real>(Stack);
  real r = vm::pop<real>(Stack);
#line 845 "runtime.in"
  {Stack->push<pen>(pen(r,g,b)); return;}
}

#line 849 "runtime.in"
// pen cmyk(real c, real m, real y, real k);
void gen51(stack *Stack)
{
  real k = vm::pop<real>(Stack);
  real y = vm::pop<real>(Stack);
  real m = vm::pop<real>(Stack);
  real c = vm::pop<real>(Stack);
#line 850 "runtime.in"
  {Stack->push<pen>(pen(c,m,y,k)); return;}  
}

#line 854 "runtime.in"
// pen gray(real gray);
void gen52(stack *Stack)
{
  real gray = vm::pop<real>(Stack);
#line 855 "runtime.in"
  {Stack->push<pen>(pen(gray)); return;}
}

#line 859 "runtime.in"
// realarray* colors(pen p);
void gen53(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 860 "runtime.in"  
  int n=ColorComponents[p.colorspace()];
  array *a=new array(n);
  
  switch(n) {
  case 0:
    break;
  case 1: 
    (*a)[0]=p.gray(); 
    break;
  case 3:
    (*a)[0]=p.red(); 
    (*a)[1]=p.green(); 
    (*a)[2]=p.blue(); 
    break;
  case 4:
    (*a)[0]=p.cyan();
    (*a)[1]=p.magenta(); 
    (*a)[2]=p.yellow(); 
    (*a)[3]=p.black();
    break;
  default:
    break;
  }
  {Stack->push<realarray*>(a); return;}
}

#line 887 "runtime.in"
// pen pattern(string *s);
void gen54(stack *Stack)
{
  string * s = vm::pop<string *>(Stack);
#line 888 "runtime.in"
  {Stack->push<pen>(pen(setpattern,*s)); return;}
}

#line 892 "runtime.in"
// string pattern(pen p);
void gen55(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 893 "runtime.in"
  {Stack->push<string>(p.fillpattern()); return;}  
}

#line 897 "runtime.in"
// pen fillrule(int n);
void gen56(stack *Stack)
{
  int n = vm::pop<int>(Stack);
#line 898 "runtime.in"
  {Stack->push<pen>(pen(n >= 0 && n < nFill ? (FillRule) n : DEFFILL)); return;}
}

#line 902 "runtime.in"
// int fillrule(pen p);
void gen57(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 903 "runtime.in"
  {Stack->push<int>(p.Fillrule()); return;}  
}

#line 907 "runtime.in"
// pen linetype(string *s, double offset=0, bool scale=true, bool adjust=true);
void gen58(stack *Stack)
{
  bool adjust = vm::pop<bool>(Stack,true);
  bool scale = vm::pop<bool>(Stack,true);
  double offset = vm::pop<double>(Stack,0);
  string * s = vm::pop<string *>(Stack);
#line 908 "runtime.in"
  {Stack->push<pen>(pen(LineType(*s,offset,scale,adjust))); return;} 
}

#line 912 "runtime.in"
// string linetype(pen p);
void gen59(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 913 "runtime.in"
  {Stack->push<string>(p.stroke()); return;}  
}

#line 917 "runtime.in"
// pen linecap(int n);
void gen60(stack *Stack)
{
  int n = vm::pop<int>(Stack);
#line 918 "runtime.in"
  {Stack->push<pen>(pen(setlinecap,n >= 0 && n < nCap ? n : DEFCAP)); return;}
}

#line 922 "runtime.in"
// int linecap(pen p);
void gen61(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 923 "runtime.in"
  {Stack->push<int>(p.cap()); return;}  
}

#line 927 "runtime.in"
// pen linejoin(int n);
void gen62(stack *Stack)
{
  int n = vm::pop<int>(Stack);
#line 928 "runtime.in"
  {Stack->push<pen>(pen(setlinejoin,n >= 0 && n < nJoin ? n : DEFJOIN)); return;}
}

#line 932 "runtime.in"
// int linejoin(pen p);
void gen63(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 933 "runtime.in"
  {Stack->push<int>(p.join()); return;}  
}

#line 937 "runtime.in"
// pen linewidth(real x);
void gen64(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 938 "runtime.in"
  {Stack->push<pen>(pen(setlinewidth,x >= 0.0 ? x : DEFWIDTH)); return;}
}

#line 942 "runtime.in"
// real linewidth(pen p);
void gen65(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 943 "runtime.in"
  {Stack->push<real>(p.width()); return;}  
}

#line 947 "runtime.in"
// pen fontcommand(string *s);
void gen66(stack *Stack)
{
  string * s = vm::pop<string *>(Stack);
#line 948 "runtime.in"
  {Stack->push<pen>(pen(setfont,*s)); return;}
}

#line 952 "runtime.in"
// string font(pen p);
void gen67(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 953 "runtime.in"
  {Stack->push<string>(p.Font()); return;}
}

#line 957 "runtime.in"
// pen fontsize(real size, real lineskip);
void gen68(stack *Stack)
{
  real lineskip = vm::pop<real>(Stack);
  real size = vm::pop<real>(Stack);
#line 958 "runtime.in"
  {Stack->push<pen>(pen(setfontsize,size > 0.0 ? size : 0.0,
	     lineskip > 0.0 ? lineskip : 0.0)); return;}
}

#line 963 "runtime.in"
// real fontsize(pen p);
void gen69(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 964 "runtime.in"
  {Stack->push<real>(p.size()); return;}
}

#line 968 "runtime.in"
// real lineskip(pen p);
void gen70(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 969 "runtime.in"
  {Stack->push<real>(p.Lineskip()); return;}  
}

#line 973 "runtime.in"
// pen overwrite(int n);
void gen71(stack *Stack)
{
  int n = vm::pop<int>(Stack);
#line 974 "runtime.in"
  {Stack->push<pen>(pen(setoverwrite,n >= 0 && n < nOverwrite ? (overwrite_t) n :
	     DEFWRITE)); return;}
}

#line 979 "runtime.in"
// int overwrite(pen p);
void gen72(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 980 "runtime.in"
  {Stack->push<int>(p.Overwrite()); return;}  
}

#line 984 "runtime.in"
// pen basealign(int n);
void gen73(stack *Stack)
{
  int n = vm::pop<int>(Stack);
#line 985 "runtime.in"
  {Stack->push<pen>(pen(n >= 0 && n < nBaseLine ? (BaseLine) n : DEFBASE)); return;}
}

#line 989 "runtime.in"
// int basealign(pen p);
void gen74(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 990 "runtime.in"
  {Stack->push<int>(p.Baseline()); return;}
}

#line 994 "runtime.in"
// path nib(pen p);
void gen75(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
#line 995 "runtime.in"
  static path nullpath;
  path *g=p.Path();
  {Stack->push<path>(g ? *g : nullpath); return;}
}

#line 1001 "runtime.in"
// pen makepen(path p);
void gen76(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 1002 "runtime.in"
  {Stack->push<pen>(p.size() == 0 ? pen() : pen(new path(p))); return;}
}

#line 1006 "runtime.in"
// void _draw(picture *f, path g, pen p);
void gen77(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  path g = vm::pop<path>(Stack);
  picture * f = vm::pop<picture *>(Stack);
#line 1007 "runtime.in"
  f->append(new drawPath(g,p));
}

#line 1011 "runtime.in"
// void endclip(picture *f);
void gen78(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 1012 "runtime.in"
  f->append(new drawClipEnd(false));
}

#line 1016 "runtime.in"
// void gsave(picture *f);
void gen79(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 1017 "runtime.in"
  f->append(new drawGsave());
}

#line 1021 "runtime.in"
// void grestore(picture *f);
void gen80(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 1022 "runtime.in"
  f->append(new drawGrestore());
}

#line 1026 "runtime.in"
// void begingroup(picture *f);
void gen81(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 1027 "runtime.in"
  f->append(new drawBegin());
}

#line 1031 "runtime.in"
// void endgroup(picture *f);
void gen82(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
#line 1032 "runtime.in"
  f->append(new drawEnd());
}

#line 1036 "runtime.in"
// void add(picture *dest, picture *src);
void gen83(stack *Stack)
{
  picture * src = vm::pop<picture *>(Stack);
  picture * dest = vm::pop<picture *>(Stack);
#line 1037 "runtime.in"
  dest->add(*src);
}

#line 1041 "runtime.in"
// void prepend(picture *dest, picture *src);
void gen84(stack *Stack)
{
  picture * src = vm::pop<picture *>(Stack);
  picture * dest = vm::pop<picture *>(Stack);
#line 1042 "runtime.in"
  dest->prepend(*src);
}


// Interactive mode
#line 1048 "runtime.in"
// bool interact();
void gen85(stack *Stack)
{
#line 1049 "runtime.in"
  {Stack->push<bool>(interact::interactive); return;}
}

#line 1054 "runtime.in"
// void uptodate(bool b);
void gen86(stack *Stack)
{
  bool b = vm::pop<bool>(Stack);
#line 1055 "runtime.in"
  interact::uptodate=b;
}

#line 1059 "runtime.in"
// bool uptodate();
void gen87(stack *Stack)
{
#line 1060 "runtime.in"
  {Stack->push<bool>(interact::uptodate); return;}
}


// System commands
#line 1066 "runtime.in"
// int system(string *str);
void gen88(stack *Stack)
{
  string * str = vm::pop<string *>(Stack);
#line 1067 "runtime.in"
  if(safe) error("system() call disabled; override with option -unsafe");
  else {Stack->push<int>(System(str->c_str())); return;}
}

#line 1073 "runtime.in"
// void abort(string *msg);
void gen89(stack *Stack)
{
  string * msg = vm::pop<string *>(Stack);
#line 1074 "runtime.in"
  error(msg->c_str());
}

#line 1078 "runtime.in"
// void assert(bool b);
void gen90(stack *Stack)
{
  bool b = vm::pop<bool>(Stack);
#line 1079 "runtime.in"
  flush(cout);
  if(!b) error("assert FAILED.");
}

#line 1084 "runtime.in"
// void _eval(string *s, bool embedded);
void gen91(stack *Stack)
{
  bool embedded = vm::pop<bool>(Stack);
  string * s = vm::pop<string *>(Stack);
#line 1085 "runtime.in"
  loop::doITree(parser::parseString(*s),embedded);
}

#line 1089 "runtime.in"
// void _eval(runnable *s, bool embedded);
void gen92(stack *Stack)
{
  bool embedded = vm::pop<bool>(Stack);
  runnable * s = vm::pop<runnable *>(Stack);
#line 1090 "runtime.in"
  loop::doIRunnable(s,embedded);
}

#line 1094 "runtime.in"
// void gui(real x=1);
void gen93(stack *Stack)
{
  real x = vm::pop<real>(Stack,1);
#line 1095 "runtime.in" 
  Setting("deconstruct")=(x > 0.0 ? x : 0.0);
}

#line 1099 "runtime.in"
// bool deconstruct();
void gen94(stack *Stack)
{
#line 1100 "runtime.in" 
  {Stack->push<bool>(getSetting<real>("deconstruct")); return;}
}

#line 1104 "runtime.in"
// void readGUI();
void gen95(stack *)
{
#line 1105 "runtime.in"
  static bool first=true;
  string name=buildname(getSetting<string>("outname"),"gui");
  std::ifstream exists(name.c_str());
  if(exists) {
    if((getSetting<bool>("clearGUI") && !interact::interactive) ||
       (first && interact::interactive)) unlink(name.c_str());
    else {
      if (!getSetting<bool>("ignoreGUI")) {
	string cmd=string("include \"")+name+string("\";");
	absyntax::block *ast = parser::parseString(cmd);
	loop::doITree(ast,true);
      }
    }
  }
  first=false;
}

// Wrapper for the stack::load() method.
#line 1124 "runtime.in"
void loadModule(stack *Stack)
{
  string * index = vm::pop<string *>(Stack);
#line 1125 "runtime.in"
  Stack->load(*index);
}

#line 1129 "runtime.in"
// string cd(string *d);
void gen97(stack *Stack)
{
  string * d = vm::pop<string *>(Stack);
#line 1130 "runtime.in"
  int rc=setPath(d->c_str());
  if(rc != 0) {
    ostringstream buf;
    buf << "Cannot change to directory '" << *d << "'";
    error(buf);
  }
  char *p=getPath();
  if(p && interact::interactive) 
    cout << p << endl;
  {Stack->push<string>(p); return;}
}

#line 1143 "runtime.in"
// void scroll(int n);
void gen98(stack *Stack)
{
  int n = vm::pop<int>(Stack);
#line 1144 "runtime.in"
  scrollLines=n;
}


// Path operations
#line 1150 "runtime.in"
void nullPath(stack *Stack)
{
#line 1151 "runtime.in"
  static path nullpath;
  {Stack->push<path>(nullpath); return;}
}

#line 1157 "runtime.in"
// pair point(path p, int n);
void gen100(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);
#line 1158 "runtime.in"
  {Stack->push<pair>(p.point(n)); return;}
}

#line 1162 "runtime.in"
// pair point(path p, real t);
void gen101(stack *Stack)
{
  real t = vm::pop<real>(Stack);
  path p = vm::pop<path>(Stack);
#line 1163 "runtime.in"
  {Stack->push<pair>(p.point(t)); return;}
}

#line 1167 "runtime.in"
// pair precontrol(path p, int n);
void gen102(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);
#line 1168 "runtime.in"
  {Stack->push<pair>(p.precontrol(n)); return;}
}

#line 1172 "runtime.in"
// pair precontrol(path p, real t);
void gen103(stack *Stack)
{
  real t = vm::pop<real>(Stack);
  path p = vm::pop<path>(Stack);
#line 1173 "runtime.in"
  {Stack->push<pair>(p.precontrol(t)); return;}
}

#line 1177 "runtime.in"
// pair postcontrol(path p, int n);
void gen104(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);
#line 1178 "runtime.in"
  {Stack->push<pair>(p.postcontrol(n)); return;}
}

#line 1182 "runtime.in"
// pair postcontrol(path p, real t);
void gen105(stack *Stack)
{
  real t = vm::pop<real>(Stack);
  path p = vm::pop<path>(Stack);
#line 1183 "runtime.in"
  {Stack->push<pair>(p.postcontrol(t)); return;}
}

#line 1187 "runtime.in"
// pair dir(path p, int n);
void gen106(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);
#line 1188 "runtime.in"
  {Stack->push<pair>(unit(p.direction(n))); return;}
}

#line 1192 "runtime.in"
// pair dir(path p, real t);
void gen107(stack *Stack)
{
  real t = vm::pop<real>(Stack);
  path p = vm::pop<path>(Stack);
#line 1193 "runtime.in"
  {Stack->push<pair>(unit(p.direction(t))); return;}
}

#line 1197 "runtime.in"
// path reverse(path p);
void gen108(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 1198 "runtime.in"
  {Stack->push<path>(p.reverse()); return;}
}

#line 1202 "runtime.in"
// path subpath(path p, int b, int e);
void gen109(stack *Stack)
{
  int e = vm::pop<int>(Stack);
  int b = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);
#line 1203 "runtime.in"
  {Stack->push<path>(p.subpath(b,e)); return;}
}

#line 1207 "runtime.in"
// path subpath(path p, real b, real e);
void gen110(stack *Stack)
{
  real e = vm::pop<real>(Stack);
  real b = vm::pop<real>(Stack);
  path p = vm::pop<path>(Stack);
#line 1208 "runtime.in"
  {Stack->push<path>(p.subpath(b,e)); return;}
}

#line 1212 "runtime.in"
// int length(path p);
void gen111(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 1213 "runtime.in"
  {Stack->push<int>(p.length()); return;}
}

#line 1217 "runtime.in"
// bool cyclic(path p);
void gen112(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 1218 "runtime.in"
  {Stack->push<bool>(p.cyclic()); return;}
}

#line 1222 "runtime.in"
// bool straight(path p, int i);
void gen113(stack *Stack)
{
  int i = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);
#line 1223 "runtime.in"
  {Stack->push<bool>(p.straight(i)); return;}
}

#line 1227 "runtime.in"
// real arclength(path p);
void gen114(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 1228 "runtime.in"
  {Stack->push<real>(p.arclength()); return;}
}

#line 1232 "runtime.in"
// real arctime(path p, real dval);
void gen115(stack *Stack)
{
  real dval = vm::pop<real>(Stack);
  path p = vm::pop<path>(Stack);
#line 1233 "runtime.in"
  {Stack->push<real>(p.arctime(dval)); return;}
}

#line 1237 "runtime.in"
// real dirtime(path p, pair z);
void gen116(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
  path p = vm::pop<path>(Stack);
#line 1238 "runtime.in"
  {Stack->push<real>(p.directiontime(z)); return;}
}

#line 1242 "runtime.in"
// pair intersect(path x, path y, real fuzz=0);
void gen117(stack *Stack)
{
  real fuzz = vm::pop<real>(Stack,0);
  path y = vm::pop<path>(Stack);
  path x = vm::pop<path>(Stack);
#line 1243 "runtime.in"
  {Stack->push<pair>(intersectiontime(x,y,fuzz)); return;}
}

#line 1247 "runtime.in"
// int size(path p);
void gen118(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 1248 "runtime.in"
  {Stack->push<int>(p.size()); return;}
}

#line 1252 "runtime.in"
// path &(path p, path q);
void gen119(stack *Stack)
{
  path q = vm::pop<path>(Stack);
  path p = vm::pop<path>(Stack);
#line 1253 "runtime.in"
  {Stack->push<path>(camp::concat(p,q)); return;}
}

#line 1257 "runtime.in"
// pair min(path p);
void gen120(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 1258 "runtime.in"
  {Stack->push<pair>(p.bounds().Min()); return;}
}

#line 1262 "runtime.in"
// pair max(path p);
void gen121(stack *Stack)
{
  path p = vm::pop<path>(Stack);
#line 1263 "runtime.in"
  {Stack->push<pair>(p.bounds().Max()); return;}
}

#line 1267 "runtime.in"
// real relativedistance(real theta, real phi, real t, bool atleast);
void gen122(stack *Stack)
{
  bool atleast = vm::pop<bool>(Stack);
  real t = vm::pop<real>(Stack);
  real phi = vm::pop<real>(Stack);
  real theta = vm::pop<real>(Stack);
#line 1268 "runtime.in"
  {Stack->push<real>(camp::velocity(theta,phi,tension(t,atleast))); return;}
}

#line 1272 "runtime.in"
// bool inside(patharray *g, pair z, pen p);
void gen123(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  pair z = vm::pop<pair>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
#line 1273 "runtime.in"
  array *G=copyArray(g);
  size_t size=G->size();
  int count=0;
  for(size_t i=0; i < size; i++) 
    count += read<path *>(G,i)->inside(z);
  {Stack->push<bool>(p.inside(count)); return;}
}


// Guide operations
#line 1284 "runtime.in"
void nullGuide(stack *Stack)
{
#line 1285 "runtime.in"
  {Stack->push<guide*>(new pathguide(path())); return;}
}

#line 1290 "runtime.in"
void dotsGuide(stack *Stack)
{
  guidearray * a = vm::pop<guidearray *>(Stack);
#line 1291 "runtime.in"
  guidevector v;
  size_t size=checkArray(a);
  for (size_t i=0; i < size; ++i)
    v.push_back(a->read<guide*>(i));

  {Stack->push<guide*>(new multiguide(v)); return;}
}

#line 1300 "runtime.in"
void dashesGuide(stack *Stack)
{
  guidearray * a = vm::pop<guidearray *>(Stack);
#line 1301 "runtime.in"
  static camp::curlSpec curly;
  static specguide curlout(&curly, camp::OUT);
  static specguide curlin(&curly, camp::IN);

  size_t n=checkArray(a);

  // a--b is equivalent to a{curl 1}..{curl 1}b
  guidevector v;
  if (n > 0)
    v.push_back(a->read<guide*>(0));

  if (n==1) {
    v.push_back(&curlout);
    v.push_back(&curlin);
  }
  else
    for (size_t i=1; i<n; ++i) {
      v.push_back(&curlout);
      v.push_back(&curlin);
      v.push_back(a->read<guide*>(i));
    }

  {Stack->push<guide*>(new multiguide(v)); return;}
}

#line 1327 "runtime.in"
// guide* operator cycle();
void gen127(stack *Stack)
{
#line 1328 "runtime.in"
  {Stack->push<guide*>(new cycletokguide()); return;}
}

#line 1332 "runtime.in"
// guide* operator spec(pair z, int p);
void gen128(stack *Stack)
{
  int p = vm::pop<int>(Stack);
  pair z = vm::pop<pair>(Stack);
#line 1333 "runtime.in"
  camp::side d=(camp::side) p;
  camp::dirSpec *sp=new camp::dirSpec(angle(z));

  {Stack->push<guide*>(new specguide(sp,d)); return;}
}

#line 1340 "runtime.in"
// guide* operator curl(real gamma, int p);
void gen129(stack *Stack)
{
  int p = vm::pop<int>(Stack);
  real gamma = vm::pop<real>(Stack);
#line 1341 "runtime.in"
  camp::side d=(camp::side) p;
  camp::curlSpec *sp=new camp::curlSpec(gamma);

  {Stack->push<guide*>(new specguide(sp,d)); return;}
}

#line 1348 "runtime.in"
// guide* operator tension(real tout, real tin, bool atleast);
void gen130(stack *Stack)
{
  bool atleast = vm::pop<bool>(Stack);
  real tin = vm::pop<real>(Stack);
  real tout = vm::pop<real>(Stack);
#line 1349 "runtime.in"
  {Stack->push<guide*>(new tensionguide(tension(tout,atleast),tension(tin,atleast))); return;}
}

#line 1353 "runtime.in"
// guide* operator controls(pair zout, pair zin);
void gen131(stack *Stack)
{
  pair zin = vm::pop<pair>(Stack);
  pair zout = vm::pop<pair>(Stack);
#line 1354 "runtime.in"
  {Stack->push<guide*>(new controlguide(zout, zin)); return;}
}


// String operations
#line 1360 "runtime.in"
void emptyString(stack *Stack)
{
#line 1361 "runtime.in"
  {Stack->push<string>(emptystring); return;}
}

#line 1366 "runtime.in"
// int length(string *s);
void gen133(stack *Stack)
{
  string * s = vm::pop<string *>(Stack);
#line 1367 "runtime.in"
  {Stack->push<int>((int) s->length()); return;}
}

#line 1371 "runtime.in"
// int find(string *s, string t, int pos=0);
void gen134(stack *Stack)
{
  int pos = vm::pop<int>(Stack,0);
  string t = vm::pop<string>(Stack);
  string * s = vm::pop<string *>(Stack);
#line 1372 "runtime.in"
  {Stack->push<int>((int) s->find(t,pos)); return;}
}

#line 1376 "runtime.in"
// int rfind(string *s, string t, int pos=-1);
void gen135(stack *Stack)
{
  int pos = vm::pop<int>(Stack,-1);
  string t = vm::pop<string>(Stack);
  string * s = vm::pop<string *>(Stack);
#line 1377 "runtime.in"
  {Stack->push<int>((int) s->rfind(t,pos)); return;}
}

#line 1381 "runtime.in"
// string reverse(string s);
void gen136(stack *Stack)
{
  string s = vm::pop<string>(Stack);
#line 1382 "runtime.in"
  reverse(s.begin(),s.end());
  {Stack->push<string>(s); return;}
}

#line 1387 "runtime.in"
// string insert(string s, int pos, string t);
void gen137(stack *Stack)
{
  string t = vm::pop<string>(Stack);
  int pos = vm::pop<int>(Stack);
  string s = vm::pop<string>(Stack);
#line 1388 "runtime.in"
  if ((size_t)pos < s.length())
    {Stack->push<string>(s.insert(pos,t)); return;}
  {Stack->push<string>(s); return;}
}

#line 1394 "runtime.in"
// string substr(string* s, int pos, int n=-1);
void gen138(stack *Stack)
{
  int n = vm::pop<int>(Stack,-1);
  int pos = vm::pop<int>(Stack);
  string* s = vm::pop<string*>(Stack);
#line 1395 "runtime.in"
  if ((size_t)pos < s->length())
    {Stack->push<string>(s->substr(pos,n)); return;}
  {Stack->push<string>(emptystring); return;}
}

#line 1401 "runtime.in"
// string erase(string s, int pos, int n);
void gen139(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  int pos = vm::pop<int>(Stack);
  string s = vm::pop<string>(Stack);
#line 1402 "runtime.in"
  if ((size_t)pos < s.length())
    {Stack->push<string>(s.erase(pos,n)); return;}
  {Stack->push<string>(s); return;} 
}

// returns a string constructed by translating all occurrences of the string
// from in an array of string pairs {from,to} to the string to in string s.
#line 1410 "runtime.in"
// string replace(string *S, stringarray2 *translate);
void gen140(stack *Stack)
{
  stringarray2 * translate = vm::pop<stringarray2 *>(Stack);
  string * S = vm::pop<string *>(Stack);
#line 1411 "runtime.in"
  size_t size=checkArray(translate);
  for(size_t i=0; i < size; i++) {
    array *a=read<array*>(translate,i);
    checkArray(a);
  }
  const char *p=S->c_str();
  ostringstream buf;
  while(*p) {
    for(size_t i=0; i < size;) {
      array *a=read<array*>(translate,i);
      string* from=read<string*>(a,0);
      size_t len=from->length();
      if(strncmp(p,from->c_str(),len) != 0) {i++; continue;}
      buf << read<string>(a,1);
      p += len;
      if(*p == 0) {Stack->push<string>(buf.str()); return;}
      i=0;
    }
    buf << *(p++);
  }
  {Stack->push<string>(buf.str()); return;}
}

#line 1435 "runtime.in"
// string format(string *format, int x);
void gen141(stack *Stack)
{
  int x = vm::pop<int>(Stack);
  string * format = vm::pop<string *>(Stack);
#line 1436 "runtime.in"
  const char *f=format->c_str();
  
  checkformat(f,true);
  
  int size=snprintf(NULL,0,f,x)+1;
  if(size < 1) size=255; // Workaround for non-C99 compliant systems.
  char *buf=new char[size];
  snprintf(buf,size,f,x);
  string s=string(buf);
  delete[] buf;
  {Stack->push<string>(s); return;}
}

#line 1450 "runtime.in"
// string format(string *format, real x);
void gen142(stack *Stack)
{
  real x = vm::pop<real>(Stack);
  string * format = vm::pop<string *>(Stack);
#line 1451 "runtime.in"
  ostringstream out;
  
  checkformat(format->c_str(),false);
  
  const char *phantom="\\phantom{+}";
  const char *p0=format->c_str();
  
  const char *p=p0;
  const char *start=NULL;
  while (*p != 0) {
    if(*p == '%') {
      p++;
      if(*p != '%') {start=p-1; break;}
    }
    out << *(p++);
  }
  
  if(!start) {Stack->push<string>(out.str()); return;}
  
  // Allow at most 1 argument  
  while (*p != 0) {
    if(*p == '*' || *p == '$') {Stack->push<string>(out.str()); return;}
    if(isupper(*p) || islower(*p)) {p++; break;}
    p++;
  }
  
  const char *tail=p;
  string f=format->substr(start-p0,tail-start);
  int size=snprintf(NULL,0,f.c_str(),x)+1;
  if(size < 1) size=255; // Workaround for non-C99 compliant systems.
  char *buf=new char[size];
  snprintf(buf,size,f.c_str(),x);

  bool trailingzero=f.find("#") < string::npos;
  bool plus=f.find("+") < string::npos;
  bool space=f.find(" ") < string::npos;
  
  char *q=buf; // beginning of formatted number

  if(*q == ' ') {
    out << phantom;
    q++;
  }
  
  // Remove any spurious sign
  if(*q == '-' || *q == '+') {
    p=q+1;
    bool zero=true;
    while(*p != 0) {
      if(!isdigit(*p) && *p != '.') break;
      if(isdigit(*p) && *p != '0') {zero=false; break;}
      p++;
    }
    if(zero) {
      q++;
      if(plus || space) out << phantom;
    }
  }
  
  const char *r=p=q;
  bool dp=false;
  while(*r != 0 && (isdigit(*r) || *r == '.' || *r == '+' || *r == '-')) {
    if(*r == '.') dp=true;
    r++;
  }
  if(dp) { // Remove trailing zeros and/or decimal point
    r--;
    unsigned int n=0;
    while(r > q && *r == '0') {r--; n++;}
    if(*r == '.') {r--; n++;}
    while(q <= r) out << *(q++);
    if(!trailingzero) q += n;
  }
  
  bool zero=(r == p && *r == '0') && !trailingzero;
  
  // Translate "E+/E-/e+/e-" exponential notation to TeX
  while(*q != 0) {
    if((*q == 'E' || *q == 'e') && (*(q+1) == '+' || *(q+1) == '-')) {
      if(!zero) out << "\\!\\times\\!10^{";
      bool plus=(*(q+1) == '+');
      q++;
      if(plus) q++;
      if(*q == '-') out << *(q++);
      while(*q == '0' && (zero || isdigit(*(q+1)))) q++;
      while(isdigit(*q)) out << *(q++);
      if(!zero) {
	if(plus) out << phantom;
	out << "}";
      }
      break;
    }
    out << *(q++);
  }
  
  while(*tail != 0) 
    out << *(tail++);
  
  delete[] buf;
  {Stack->push<string>(out.str()); return;}
}

#line 1554 "runtime.in"
// string string(real x, int digits);
void gen143(stack *Stack)
{
  int digits = vm::pop<int>(Stack);
  real x = vm::pop<real>(Stack);
#line 1555 "runtime.in"
  std::ostringstream buf;
  buf.precision(digits);
  buf << x;
  {Stack->push<string>(buf.str()); return;}
}

#line 1562 "runtime.in"
// string time(string *format);
void gen144(stack *Stack)
{
  string * format = vm::pop<string *>(Stack);
#line 1563 "runtime.in"
#ifdef HAVE_STRFTIME
  static const size_t n=256;
  static char Time[n];
  const time_t bintime=time(NULL);
  strftime(Time,n,format->c_str(),localtime(&bintime));
  {Stack->push<string>(Time); return;}
#else  
  {Stack->push<string>(*format); return;}
#endif  
}


// Math
#line 1577 "runtime.in"
// real ^(real x, int y);
void gen145(stack *Stack)
{
  int y = vm::pop<int>(Stack);
  real x = vm::pop<real>(Stack);
#line 1578 "runtime.in"
  {Stack->push<real>(pow(x,y)); return;}
}

#line 1583 "runtime.in"
// int quotient(int x, int y);
void gen146(stack *Stack)
{
  int y = vm::pop<int>(Stack);
  int x = vm::pop<int>(Stack);
#line 1584 "runtime.in" 
  if (y == 0) dividebyzero();
// Implementation-independent definition of integer division: round down
  {Stack->push<int>((x-portableMod(x,y))/y); return;}
}

#line 1590 "runtime.in"
// int abs(int x);
void gen147(stack *Stack)
{
  int x = vm::pop<int>(Stack);
#line 1591 "runtime.in" 
  {Stack->push<int>(abs(x)); return;}
}

#line 1595 "runtime.in"
// int sgn(real x);
void gen148(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1596 "runtime.in" 
  {Stack->push<int>(sgn(x)); return;}
}

#line 1600 "runtime.in"
// int rand();
void gen149(stack *Stack)
{
#line 1601 "runtime.in" 
  {Stack->push<int>(rand()); return;}
}

#line 1605 "runtime.in"
// void srand(int seed);
void gen150(stack *Stack)
{
  int seed = vm::pop<int>(Stack);
#line 1606 "runtime.in" 
  srand(seed);
}

#line 1610 "runtime.in"
// int ceil(real x);
void gen151(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1611 "runtime.in" 
  real y=ceil(x);
  checkint(y,0);
  {Stack->push<int>((int) y); return;}
}

#line 1617 "runtime.in"
// int floor(real x);
void gen152(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1618 "runtime.in" 
  real y=floor(x);
  checkint(y,0);
  {Stack->push<int>((int) y); return;}
}

#line 1624 "runtime.in"
// int round(real x);
void gen153(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1625 "runtime.in" 
  if(fabs(x) >= INT_MAX+0.5) integeroverflow(0);
  {Stack->push<int>(Round(x)); return;}
}

#line 1630 "runtime.in"
// int Ceil(real x);
void gen154(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1631 "runtime.in" 
  {Stack->push<int>(Ceil(x)); return;}
}

#line 1635 "runtime.in"
// int Floor(real x);
void gen155(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1636 "runtime.in" 
  {Stack->push<int>(Floor(x)); return;}
}

#line 1640 "runtime.in"
// int Round(real x);
void gen156(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1641 "runtime.in" 
  {Stack->push<int>(Round(intcap(x))); return;}
}

#line 1645 "runtime.in"
// real fmod(real x, real y);
void gen157(stack *Stack)
{
  real y = vm::pop<real>(Stack);
  real x = vm::pop<real>(Stack);
#line 1646 "runtime.in"
  if (y == 0.0) dividebyzero();
  {Stack->push<real>(fmod(x,y)); return;}
}

#line 1651 "runtime.in"
// real atan2(real y, real x);
void gen158(stack *Stack)
{
  real x = vm::pop<real>(Stack);
  real y = vm::pop<real>(Stack);
#line 1652 "runtime.in" 
  {Stack->push<real>(atan2(y,x)); return;}
}

#line 1656 "runtime.in"
// real hypot(real x, real y);
void gen159(stack *Stack)
{
  real y = vm::pop<real>(Stack);
  real x = vm::pop<real>(Stack);
#line 1657 "runtime.in" 
  {Stack->push<real>(hypot(x,y)); return;}
}

#line 1661 "runtime.in"
// real remainder(real x, real y);
void gen160(stack *Stack)
{
  real y = vm::pop<real>(Stack);
  real x = vm::pop<real>(Stack);
#line 1662 "runtime.in" 
  {Stack->push<real>(remainder(x,y)); return;}
}

#line 1666 "runtime.in"
// real J(int n, real x);
void gen161(stack *Stack)
{
  real x = vm::pop<real>(Stack);
  int n = vm::pop<int>(Stack);
#line 1667 "runtime.in"
  {Stack->push<real>(jn(n,x)); return;}
}

#line 1671 "runtime.in"
// real Y(int n, real x);
void gen162(stack *Stack)
{
  real x = vm::pop<real>(Stack);
  int n = vm::pop<int>(Stack);
#line 1672 "runtime.in"
  {Stack->push<real>(yn(n,x)); return;}
}

#line 1676 "runtime.in"
// real erf(real x);
void gen163(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1677 "runtime.in"
  {Stack->push<real>(erf(x)); return;}
}

#line 1681 "runtime.in"
// real erfc(real x);
void gen164(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1682 "runtime.in"
  {Stack->push<real>(erfc(x)); return;}
}

#line 1686 "runtime.in"
// real gamma(real x);
void gen165(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1687 "runtime.in"
#ifdef HAVE_TGAMMA
  {Stack->push<real>(tgamma(x)); return;}
#else
 real lg = lgamma(x);
 {Stack->push<real>(signgam*exp(lg)); return;}
#endif
}

#line 1696 "runtime.in"
// realarray* quadraticroots(real a, real b, real c);
void gen166(stack *Stack)
{
  real c = vm::pop<real>(Stack);
  real b = vm::pop<real>(Stack);
  real a = vm::pop<real>(Stack);
#line 1697 "runtime.in"
  quadraticroots q(a,b,c);
  array *roots=new array(q.roots);
  if(q.roots >= 1) (*roots)[0]=q.t1;
  if(q.roots == 2) (*roots)[1]=q.t2;
  {Stack->push<realarray*>(roots); return;}
}

#line 1705 "runtime.in"
// realarray* cubicroots(real a, real b, real c, real d);
void gen167(stack *Stack)
{
  real d = vm::pop<real>(Stack);
  real c = vm::pop<real>(Stack);
  real b = vm::pop<real>(Stack);
  real a = vm::pop<real>(Stack);
#line 1706 "runtime.in"
  cubicroots q(a,b,c,d);
  array *roots=new array(q.roots);
  if(q.roots >= 1) (*roots)[0]=q.t1;
  if(q.roots >= 2) (*roots)[1]=q.t2;
  if(q.roots == 3) (*roots)[2]=q.t3;
  {Stack->push<realarray*>(roots); return;}
}

  
// Transforms
#line 1717 "runtime.in"
// bool ==(transform a, transform b);
void gen168(stack *Stack)
{
  transform b = vm::pop<transform>(Stack);
  transform a = vm::pop<transform>(Stack);
#line 1718 "runtime.in"
  {Stack->push<bool>(a == b); return;}
}

#line 1723 "runtime.in"
// bool !=(transform a, transform b);
void gen169(stack *Stack)
{
  transform b = vm::pop<transform>(Stack);
  transform a = vm::pop<transform>(Stack);
#line 1724 "runtime.in"
  {Stack->push<bool>(a != b); return;}
}

#line 1728 "runtime.in"
// transform operator +(transform a, transform b);
void gen170(stack *Stack)
{
  transform b = vm::pop<transform>(Stack);
  transform a = vm::pop<transform>(Stack);
#line 1729 "runtime.in"
  {Stack->push<transform>(a+b); return;}
}

#line 1733 "runtime.in"
// transform *(transform a, transform b);
void gen171(stack *Stack)
{
  transform b = vm::pop<transform>(Stack);
  transform a = vm::pop<transform>(Stack);
#line 1734 "runtime.in"
  {Stack->push<transform>(a*b); return;}
}

#line 1738 "runtime.in"
// pair *(transform t, pair z);
void gen172(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
  transform t = vm::pop<transform>(Stack);
#line 1739 "runtime.in"
  {Stack->push<pair>(t*z); return;}
}

#line 1743 "runtime.in"
// path *(transform t, path g);
void gen173(stack *Stack)
{
  path g = vm::pop<path>(Stack);
  transform t = vm::pop<transform>(Stack);
#line 1744 "runtime.in"
  {Stack->push<path>(transformed(t,g)); return;}
}

#line 1748 "runtime.in"
// pen *(transform t, pen p);
void gen174(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  transform t = vm::pop<transform>(Stack);
#line 1749 "runtime.in"
  {Stack->push<pen>(transformed(t,p)); return;}
}

#line 1753 "runtime.in"
// picture* *(transform t, picture *f);
void gen175(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
  transform t = vm::pop<transform>(Stack);
#line 1754 "runtime.in"
  {Stack->push<picture*>(transformed(t,f)); return;}
}

#line 1758 "runtime.in"
// transform ^(transform t, int n);
void gen176(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  transform t = vm::pop<transform>(Stack);
#line 1759 "runtime.in"
  transform T;
  if(n < 0) {
    n=-n;
    t=inverse(t);
  }
  for(int i=0; i < n; i++) T=T*t;
  {Stack->push<transform>(T); return;}
}

#line 1769 "runtime.in"
void transformXPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1770 "runtime.in"
  {Stack->push<real>(t.getx()); return;}
}

#line 1774 "runtime.in"
void transformYPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1775 "runtime.in"
  {Stack->push<real>(t.gety()); return;}
}

#line 1779 "runtime.in"
void transformXXPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1780 "runtime.in"
  {Stack->push<real>(t.getxx()); return;}
}

#line 1784 "runtime.in"
void transformXYPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1785 "runtime.in"
  {Stack->push<real>(t.getxy()); return;}
}

#line 1789 "runtime.in"
void transformYXPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1790 "runtime.in"
  {Stack->push<real>(t.getyx()); return;}
}

#line 1794 "runtime.in"
void transformYYPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1795 "runtime.in"
  {Stack->push<real>(t.getyy()); return;}
}

#line 1799 "runtime.in"
void real6ToTransform(stack *Stack)
{
  real yy = vm::pop<real>(Stack);
  real yx = vm::pop<real>(Stack);
  real xy = vm::pop<real>(Stack);
  real xx = vm::pop<real>(Stack);
  real y = vm::pop<real>(Stack);
  real x = vm::pop<real>(Stack);
#line 1801 "runtime.in"
  {Stack->push<transform>(transform(x,y,xx,xy,yx,yy)); return;}
}

#line 1805 "runtime.in"
// transform shift(transform t);
void gen184(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1806 "runtime.in"
  {Stack->push<transform>(transform(t.getx(),t.gety(),0,0,0,0)); return;}
}

#line 1810 "runtime.in"
// transform shiftless(transform t);
void gen185(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1811 "runtime.in"
  {Stack->push<transform>(transform(0,0,t.getxx(),t.getxy(),t.getyx(),t.getyy())); return;}
}

#line 1815 "runtime.in"
// transform identity();
void transformIdentity(stack *Stack)
{
#line 1816 "runtime.in"
  {Stack->push<transform>(identity()); return;}
}

#line 1820 "runtime.in"
// transform inverse(transform t);
void gen187(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);
#line 1821 "runtime.in"
  {Stack->push<transform>(inverse(t)); return;}
}

#line 1825 "runtime.in"
// transform shift(pair z);
void gen188(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 1826 "runtime.in"
  {Stack->push<transform>(shift(z)); return;}
}

#line 1830 "runtime.in"
// transform shift(real x, real y);
void gen189(stack *Stack)
{
  real y = vm::pop<real>(Stack);
  real x = vm::pop<real>(Stack);
#line 1831 "runtime.in"
  {Stack->push<transform>(shift(pair(x,y))); return;}
}

#line 1835 "runtime.in"
// transform xscale(real x);
void gen190(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1836 "runtime.in"
  {Stack->push<transform>(xscale(x)); return;}
}

#line 1840 "runtime.in"
// transform yscale(real y);
void gen191(stack *Stack)
{
  real y = vm::pop<real>(Stack);
#line 1841 "runtime.in"
  {Stack->push<transform>(yscale(y)); return;}
}

#line 1845 "runtime.in"
// transform scale(real x);
void gen192(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1846 "runtime.in"
  {Stack->push<transform>(scale(x)); return;}
}

#line 1850 "runtime.in"
// transform slant(real s);
void gen193(stack *Stack)
{
  real s = vm::pop<real>(Stack);
#line 1851 "runtime.in"
  {Stack->push<transform>(slant(s)); return;}
}

#line 1855 "runtime.in"
// transform rotate(real angle, pair z=0);
void gen194(stack *Stack)
{
  pair z = vm::pop<pair>(Stack,0);
  real angle = vm::pop<real>(Stack);
#line 1856 "runtime.in"
  {Stack->push<transform>(rotatearound(z,radians(angle))); return;}
}

#line 1860 "runtime.in"
// transform reflect(pair a, pair b);
void gen195(stack *Stack)
{
  pair b = vm::pop<pair>(Stack);
  pair a = vm::pop<pair>(Stack);
#line 1861 "runtime.in"
  {Stack->push<transform>(reflectabout(a,b)); return;}
}


// Pair operations
#line 1867 "runtime.in"
void pairZero(stack *Stack)
{
#line 1868 "runtime.in"
  static pair zero;
  {Stack->push<pair>(zero); return;}
}

#line 1874 "runtime.in"
void realRealToPair(stack *Stack)
{
  real y = vm::pop<real>(Stack);
  real x = vm::pop<real>(Stack);
#line 1875 "runtime.in"
  {Stack->push<pair>(pair(x,y)); return;}
}

#line 1879 "runtime.in"
void pairNegate(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 1880 "runtime.in"
  {Stack->push<pair>(-z); return;}
}

#line 1884 "runtime.in"
// real xpart(pair z);
void pairXPart(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 1885 "runtime.in"
  {Stack->push<real>(z.getx()); return;}
}

#line 1889 "runtime.in"
// real ypart(pair z);
void pairYPart(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 1890 "runtime.in"
  {Stack->push<real>(z.gety()); return;}
}

#line 1894 "runtime.in"
// real length(pair z);
void gen201(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 1895 "runtime.in"
  {Stack->push<real>(z.length()); return;}
}

#line 1899 "runtime.in"
// real abs(pair z);
void gen202(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 1900 "runtime.in"
  {Stack->push<real>(z.length()); return;}
}

// Return the angle of z in radians.
#line 1905 "runtime.in"
// real angle(pair z, bool warn=true);
void gen203(stack *Stack)
{
  bool warn = vm::pop<bool>(Stack,true);
  pair z = vm::pop<pair>(Stack);
#line 1906 "runtime.in"
  if(!warn && z.getx() == 0.0 && z.gety() == 0.0) {Stack->push<real>(0.0); return;}
  {Stack->push<real>(z.angle()); return;}
}

// Return the angle of z in degrees in the interval [0,360).
#line 1912 "runtime.in"
// real degrees(pair z, bool warn=true);
void gen204(stack *Stack)
{
  bool warn = vm::pop<bool>(Stack,true);
  pair z = vm::pop<pair>(Stack);
#line 1913 "runtime.in"
  if(!warn && z.getx() == 0.0 && z.gety() == 0.0) {Stack->push<real>(0.0); return;}
  {Stack->push<real>(principalBranch(degrees(z.angle()))); return;}
}

// Convert degrees to radians.
#line 1919 "runtime.in"
// real radians(real degrees);
void gen205(stack *Stack)
{
  real degrees = vm::pop<real>(Stack);
#line 1920 "runtime.in"
  {Stack->push<real>(radians(degrees)); return;}
}

// Convert radians to degrees.
#line 1925 "runtime.in"
// real degrees(real radians);
void gen206(stack *Stack)
{
  real radians = vm::pop<real>(Stack);
#line 1926 "runtime.in"
  {Stack->push<real>(degrees(radians)); return;}
}

// Convert radians to degrees in [0,360).
#line 1931 "runtime.in"
// real Degrees(real radians);
void gen207(stack *Stack)
{
  real radians = vm::pop<real>(Stack);
#line 1932 "runtime.in"
  {Stack->push<real>(principalBranch(degrees(radians))); return;}
}

#line 1936 "runtime.in"
// real Sin(real deg);
void gen208(stack *Stack)
{
  real deg = vm::pop<real>(Stack);
#line 1937 "runtime.in"
  {Stack->push<real>(sin(radians(deg))); return;}
}

#line 1941 "runtime.in"
// real Cos(real deg);
void gen209(stack *Stack)
{
  real deg = vm::pop<real>(Stack);
#line 1942 "runtime.in"
  {Stack->push<real>(cos(radians(deg))); return;}
}

#line 1946 "runtime.in"
// real Tan(real deg);
void gen210(stack *Stack)
{
  real deg = vm::pop<real>(Stack);
#line 1947 "runtime.in"
  {Stack->push<real>(tan(radians(deg))); return;}
}

#line 1951 "runtime.in"
// real aSin(real x);
void gen211(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1952 "runtime.in"
  {Stack->push<real>(degrees(asin(x))); return;}
}

#line 1956 "runtime.in"
// real aCos(real x);
void gen212(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1957 "runtime.in"
  {Stack->push<real>(degrees(acos(x))); return;}
}

#line 1961 "runtime.in"
// real aTan(real x);
void gen213(stack *Stack)
{
  real x = vm::pop<real>(Stack);
#line 1962 "runtime.in"
  {Stack->push<real>(degrees(atan(x))); return;}
}

#line 1966 "runtime.in"
// pair unit(pair z);
void gen214(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 1967 "runtime.in"
  {Stack->push<pair>(unit(z)); return;}
}

#line 1971 "runtime.in"
// pair dir(real theta);
void gen215(stack *Stack)
{
  real theta = vm::pop<real>(Stack);
#line 1972 "runtime.in"
  {Stack->push<pair>(expi(radians(theta))); return;}
}

#line 1976 "runtime.in"
// pair expi(real theta);
void gen216(stack *Stack)
{
  real theta = vm::pop<real>(Stack);
#line 1977 "runtime.in"
  {Stack->push<pair>(expi(theta)); return;}
}

#line 1981 "runtime.in"
// pair conj(pair z);
void gen217(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
#line 1982 "runtime.in"
  {Stack->push<pair>(conj(z)); return;}
}

// To avoid confusion, a dot product requires explicit pair arguments.
#line 1987 "runtime.in"
// real dot(explicit pair u, explicit pair v);
void gen218(stack *Stack)
{
  pair v = vm::pop<pair>(Stack);
  pair u = vm::pop<pair>(Stack);
#line 1988 "runtime.in"
  {Stack->push<real>(u.getx()*v.getx()+u.gety()*v.gety()); return;}
}

#line 1992 "runtime.in"
// pair minbound(pair z, pair w);
void gen219(stack *Stack)
{
  pair w = vm::pop<pair>(Stack);
  pair z = vm::pop<pair>(Stack);
#line 1993 "runtime.in"
  {Stack->push<pair>(pair(Min(z.getx(),w.getx()),Min(z.gety(),w.gety()))); return;}
}

#line 1997 "runtime.in"
// pair maxbound(pair z, pair w);
void gen220(stack *Stack)
{
  pair w = vm::pop<pair>(Stack);
  pair z = vm::pop<pair>(Stack);
#line 1998 "runtime.in"
  {Stack->push<pair>(pair(Max(z.getx(),w.getx()),Max(z.gety(),w.gety()))); return;}
}



// Triple operations
#line 2005 "runtime.in"
void tripleZero(stack *Stack)
{
#line 2006 "runtime.in"
  static triple zero;
  {Stack->push<triple>(zero); return;}
}

#line 2012 "runtime.in"
void realRealRealToTriple(stack *Stack)
{
  real z = vm::pop<real>(Stack);
  real y = vm::pop<real>(Stack);
  real x = vm::pop<real>(Stack);
#line 2013 "runtime.in"
  {Stack->push<triple>(triple(x,y,z)); return;}
}

#line 2017 "runtime.in"
// real xpart(triple v);
void tripleXPart(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2018 "runtime.in"
  {Stack->push<real>(v.getx()); return;}
}

#line 2022 "runtime.in"
// real ypart(triple v);
void tripleYPart(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2023 "runtime.in"
  {Stack->push<real>(v.gety()); return;}
}

#line 2027 "runtime.in"
// real zpart(triple v);
void tripleZPart(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2028 "runtime.in"
  {Stack->push<real>(v.getz()); return;}
}

#line 2032 "runtime.in"
// triple *(real x, triple v);
void gen226(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
  real x = vm::pop<real>(Stack);
#line 2033 "runtime.in"
  {Stack->push<triple>(x*v); return;}
}

#line 2037 "runtime.in"
// triple *(triple v, real x);
void gen227(stack *Stack)
{
  real x = vm::pop<real>(Stack);
  triple v = vm::pop<triple>(Stack);
#line 2038 "runtime.in"
  {Stack->push<triple>(x*v); return;}
}

#line 2042 "runtime.in"
// triple /(triple v, real x);
void gen228(stack *Stack)
{
  real x = vm::pop<real>(Stack);
  triple v = vm::pop<triple>(Stack);
#line 2043 "runtime.in"
  {Stack->push<triple>(v/x); return;}
}

#line 2047 "runtime.in"
// real length(triple v);
void gen229(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2048 "runtime.in"
  {Stack->push<real>(v.length()); return;}
}

#line 2052 "runtime.in"
// real abs(triple v);
void gen230(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2053 "runtime.in"
  {Stack->push<real>(v.length()); return;}
}

#line 2057 "runtime.in"
// real polar(triple v);
void gen231(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2058 "runtime.in"
  {Stack->push<real>(v.polar()); return;}
}

#line 2062 "runtime.in"
// real azimuth(triple v);
void gen232(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2063 "runtime.in"
  {Stack->push<real>(v.azimuth()); return;}
}

#line 2067 "runtime.in"
// real colatitude(triple v);
void gen233(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2068 "runtime.in"
  {Stack->push<real>(degrees(v.polar())); return;}
}

#line 2072 "runtime.in"
// real latitude(triple v);
void gen234(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2073 "runtime.in"
  {Stack->push<real>(90.0-degrees(v.polar())); return;}
}

// Return the longitude of v in [0,360).
#line 2078 "runtime.in"
// real longitude(triple v, bool warn=true);
void gen235(stack *Stack)
{
  bool warn = vm::pop<bool>(Stack,true);
  triple v = vm::pop<triple>(Stack);
#line 2079 "runtime.in"
  if(!warn && v.getx() == 0.0 && v.gety() == 0.0) {Stack->push<real>(0.0); return;}
  {Stack->push<real>(principalBranch(degrees(v.azimuth()))); return;}
}

#line 2084 "runtime.in"
// triple unit(triple v);
void gen236(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
#line 2085 "runtime.in"
  {Stack->push<triple>(unit(v)); return;}
}

#line 2089 "runtime.in"
// real dot(triple u, triple v);
void gen237(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
  triple u = vm::pop<triple>(Stack);
#line 2090 "runtime.in"
  {Stack->push<real>(u.getx()*v.getx()+u.gety()*v.gety()+u.getz()*v.getz()); return;}
}

#line 2094 "runtime.in"
// triple cross(triple u, triple v);
void gen238(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
  triple u = vm::pop<triple>(Stack);
#line 2095 "runtime.in"
  {Stack->push<triple>(triple(u.gety()*v.getz()-u.getz()*v.gety(),
		u.getz()*v.getx()-u.getx()*v.getz(),
		u.getx()*v.gety()-v.getx()*u.gety())); return;}
}

#line 2101 "runtime.in"
// triple expi(real theta, real phi);
void gen239(stack *Stack)
{
  real phi = vm::pop<real>(Stack);
  real theta = vm::pop<real>(Stack);
#line 2102 "runtime.in"
  {Stack->push<triple>(expi(theta,phi)); return;}
  real sintheta=sin(theta);
  {Stack->push<triple>(triple(sintheta*cos(phi),sintheta*sin(phi),cos(theta))); return;}
}

#line 2108 "runtime.in"
// triple dir(real theta, real phi);
void gen240(stack *Stack)
{
  real phi = vm::pop<real>(Stack);
  real theta = vm::pop<real>(Stack);
#line 2109 "runtime.in"
  {Stack->push<triple>(expi(radians(theta),radians(phi))); return;}
}

#line 2113 "runtime.in"
// triple minbound(triple u, triple v);
void gen241(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
  triple u = vm::pop<triple>(Stack);
#line 2114 "runtime.in"
  {Stack->push<triple>(triple(Min(u.getx(),v.getx()),Min(u.gety(),v.gety()),
		Min(u.getz(),v.getz()))); return;}
}

#line 2119 "runtime.in"
// triple maxbound(triple u, triple v);
void gen242(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
  triple u = vm::pop<triple>(Stack);
#line 2120 "runtime.in"
  {Stack->push<triple>(triple(Max(u.getx(),v.getx()),Max(u.gety(),v.gety()),
		Max(u.getz(),v.getz()))); return;}
}

#line 2125 "runtime.in"
// real cubiclength(triple z0, triple z0p, triple z1m, triple z1, real goal);
void gen243(stack *Stack)
{
  real goal = vm::pop<real>(Stack);
  triple z1 = vm::pop<triple>(Stack);
  triple z1m = vm::pop<triple>(Stack);
  triple z0p = vm::pop<triple>(Stack);
  triple z0 = vm::pop<triple>(Stack);
#line 2126 "runtime.in"
  {Stack->push<real>(cubiclength(z0,z0p,z1m,z1,goal)); return;}
}

#line 2130 "runtime.in"
// pair intersect(triplearray* pre1, triplearray* point1, triplearray* post1,               triplearray* pre2, triplearray* point2, triplearray* post2,	       real fuzz);
void gen244(stack *Stack)
{
  real fuzz = vm::pop<real>(Stack);
  triplearray* post2 = vm::pop<triplearray*>(Stack);
  triplearray* point2 = vm::pop<triplearray*>(Stack);
  triplearray* pre2 = vm::pop<triplearray*>(Stack);
  triplearray* post1 = vm::pop<triplearray*>(Stack);
  triplearray* point1 = vm::pop<triplearray*>(Stack);
  triplearray* pre1 = vm::pop<triplearray*>(Stack);
#line 2133 "runtime.in"
  size_t size1=checkArrays(pre1,point1);
  size_t size2=checkArrays(pre2,point2);
      
  if(checkArray(post1) != size1 || checkArray(post2) != size2)
    vm::error(arraymismatch);
  
  int single1=(size1 == 1);
  int single2=(size2 == 1);
  
  size_t Size1=size1+single1;
  size_t Size2=size2+single2;
  
  node *n1=new node[Size1];
  node *n2=new node[Size2];
      
  for(size_t i=0; i < size1; ++i)
    n1[i]=node(read<triple>(pre1,i),read<triple>(point1,i),
	       read<triple>(post1,i));

  for(size_t i=0; i < size2; ++i)
    n2[i]=node(read<triple>(pre2,i),read<triple>(point2,i),
	       read<triple>(post2,i));

  if(single1) n1[1]=n1[0];
  if(single2) n2[1]=n2[0];
  
  {Stack->push<pair>(intersect((int) Size1-1,(int) Size2-1,n1,n2,fuzz)); return;}
}


// System routines
#line 2165 "runtime.in"
// string VERSION();
void gen245(stack *Stack)
{
#line 2166 "runtime.in"
  {Stack->push<string>(VERSION); return;}
}

#line 2171 "runtime.in"
// void atexit(callable *f);
void gen246(stack *Stack)
{
  callable * f = vm::pop<callable *>(Stack);
#line 2172 "runtime.in"
  atExitFunction=f;
}

#line 2176 "runtime.in"
// callable* atexit();
void gen247(stack *Stack)
{
#line 2177 "runtime.in"
  {Stack->push<callable*>(atExitFunction); return;}
}


// Merge output files  
#line 2183 "runtime.in"
// int merge(stringarray *files, string *args, string *format);
void gen248(stack *Stack)
{
  string * format = vm::pop<string *>(Stack);
  string * args = vm::pop<string *>(Stack);
  stringarray * files = vm::pop<stringarray *>(Stack);
#line 2184 "runtime.in"
  int ret;
  
  size_t size=checkArray(files);
  
  if(!checkFormatString(*format)) return;
  
  ostringstream cmd,remove;
  cmd << "'" << getSetting<string>("convert") << "' "+*args;
  
  for(size_t i=0; i < size; i++) 
    cmd << " " << read<string>(files,i);
  
  string name=buildname(getSetting<string>("outname"),format->c_str());
  cmd << " " << name;
  ret=System(cmd,false,true,"convert");
  
  if(ret == 0)
    if(verbose > 0) cout << "Wrote " << name << endl;
  
  if(!getSetting<bool>("keep"))
    for(size_t i=0; i < size; i++) 
      unlink(read<string>(files,i).c_str());
    
  if(ret == 0 && view()) {
    ostringstream cmd;
    cmd << "'" << getSetting<string>("animate") << "' " << name;
    System(cmd,false,false,"animate","your animated GIF viewer");
  }
  
  {Stack->push<int>(ret); return;}
}


// Array operations

// Create an empty array.
#line 2221 "runtime.in"
void emptyArray(stack *Stack)
{
#line 2222 "runtime.in"
  {Stack->push<array*>(new array(0)); return;}
}

// Create a new array (technically a vector).
// This array will be multidimensional.  First the number of dimensions
// is popped off the stack, followed by each dimension in reverse order.
// The array itself is technically a one dimensional array of one
// dimension arrays and so on.
#line 2231 "runtime.in"
void newDeepArray(stack *Stack)
{
  int depth = vm::pop<int>(Stack);
#line 2232 "runtime.in"
  assert(depth > 0);

  int *dims = new int[depth];

  for (int index = depth-1; index >= 0; index--)
    dims[index] = pop<int>(Stack);

  array *a=deepArray(depth, dims);
  delete[] dims;
  {Stack->push<array*>(a); return;}
}

// Creates an array with elements already specified.  First, the number
// of elements is popped off the stack, followed by each element in
// reverse order.
#line 2248 "runtime.in"
void newInitializedArray(stack *Stack)
{
  int n = vm::pop<int>(Stack);
#line 2249 "runtime.in"
  assert(n >= 0);

  array *a = new array(n);

  for (int index = n-1; index >= 0; index--)
    (*a)[index] = pop(Stack);

  {Stack->push<array*>(a); return;}
}

// Similar to newInitializedArray, but after the n elements, append another
// array to it.
#line 2262 "runtime.in"
void newAppendedArray(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  array* tail = vm::pop<array*>(Stack);
#line 2263 "runtime.in"
  assert(n >= 0);

  array *a = new array(n);

  for (int index = n-1; index >= 0; index--)
    (*a)[index] = pop(Stack);
  
  copy(tail->begin(), tail->end(), back_inserter(*a));

  {Stack->push<array*>(a); return;}
}

// Read an element from an array. Checks for initialization & bounds.
#line 2277 "runtime.in"
void arrayRead(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  array * a = vm::pop<array *>(Stack);
#line 2278 "runtime.in"
  item& i=arrayRead(a,n);
  if (i.empty()) {
    ostringstream buf;
    buf << "read uninitialized value from array at index " << n;
    error(buf);
  }
  {Stack->push(i); return;}
}

// Read an element from an array of arrays. Check bounds and initialize
// as necessary.
#line 2290 "runtime.in"
void arrayArrayRead(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  array * a = vm::pop<array *>(Stack);
#line 2291 "runtime.in"
  item& i=arrayRead(a,n);
  if (i.empty()) i=new array(0);
  {Stack->push(i); return;}
}

// Write an element to an array.  Increase size if necessary.
#line 2298 "runtime.in"
void arrayWrite(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  array * a = vm::pop<array *>(Stack);
  item value = vm::pop(Stack);
#line 2299 "runtime.in"
  size_t len=checkArray(a);
  bool cyclic=a->cyclic();
  if(cyclic && len > 0) n=imod(n,len);
  else {
    if(cyclic) outOfBounds("writing cyclic",len,n);
    if(n < 0) outOfBounds("writing",len,n);
    if(len <= (size_t) n)
      a->resize(n+1);
  }
  (*a)[n] = value;
  {Stack->push(value); return;}
}

// Returns the length of an array.
#line 2314 "runtime.in"
void arrayLength(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2315 "runtime.in"
  {Stack->push<int>((int) checkArray(a)); return;}
}

// Return the cyclic flag for an array.
#line 2320 "runtime.in"
void arrayCyclicFlag(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2321 "runtime.in"
  checkArray(a);
  {Stack->push<bool>(a->cyclic()); return;}
}

// The helper function for the cyclic method that sets the cyclic flag.
#line 2327 "runtime.in"
void arrayCyclicHelper(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
  bool b = vm::pop<bool>(Stack);
#line 2328 "runtime.in"
  checkArray(a);
  a->cyclic(b);
}

// Set the cyclic flag for an array.
#line 2334 "runtime.in"
void arrayCyclic(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2335 "runtime.in"
  checkArray(a);
  {Stack->push<callable*>(new thunk(new bfunc(arrayCyclicHelper),a)); return;}
}

// The helper function for the push method that does the actual operation.
#line 2341 "runtime.in"
void arrayPushHelper(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
  item i = vm::pop(Stack);
#line 2342 "runtime.in"
  checkArray(a);
  a->push(i);
  {Stack->push(i); return;}
}

// Returns the push method for an array.
#line 2349 "runtime.in"
void arrayPush(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2350 "runtime.in"
  checkArray(a);
  {Stack->push<callable*>(new thunk(new bfunc(arrayPushHelper),a)); return;}
}

// The helper function for the append method that appends b to a.
#line 2356 "runtime.in"
void arrayAppendHelper(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
  array * b = vm::pop<array *>(Stack);
#line 2357 "runtime.in"
  checkArray(a);
  size_t size=checkArray(b);
  for(size_t i=0; i < size; i++)
    a->push((*b)[i]);
}

// Returns the append method for an array.
#line 2365 "runtime.in"
void arrayAppend(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2366 "runtime.in"
  checkArray(a);
  {Stack->push<callable*>(new thunk(new bfunc(arrayAppendHelper),a)); return;}
}

// The helper function for the pop method.
#line 2372 "runtime.in"
void arrayPopHelper(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2373 "runtime.in"
  size_t asize=checkArray(a);
  if(asize == 0) 
    error("cannot pop element from empty array");
  {Stack->push(a->pop()); return;}
}

// Returns the pop method for an array.
#line 2381 "runtime.in"
void arrayPop(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2382 "runtime.in"
  checkArray(a);
  {Stack->push<callable*>(new thunk(new bfunc(arrayPopHelper),a)); return;}
}

#line 2387 "runtime.in"
void arrayAlias(stack *Stack)
{
  array * b = vm::pop<array *>(Stack);
  array * a = vm::pop<array *>(Stack);
#line 2388 "runtime.in"
  {Stack->push<bool>(a==b); return;}
}

// Return array formed by indexing array a with elements of integer array b
#line 2393 "runtime.in"
void arrayIntArray(stack *Stack)
{
  array * b = vm::pop<array *>(Stack);
  array * a = vm::pop<array *>(Stack);
#line 2394 "runtime.in"
  size_t asize=checkArray(a);
  size_t bsize=checkArray(b);
  array *r=new array(bsize);
  bool cyclic=a->cyclic();
  for(size_t i=0; i < bsize; i++) {
    int index=read<int>(b,i);
    if(cyclic && asize > 0) index=imod(index,asize);
    else
      if(index < 0 || index >= (int) asize)
	outOfBounds("reading",asize,index);
    (*r)[i]=(*a)[index];
  }
  {Stack->push<array*>(r); return;}
}

// returns the complement of the integer array a in {1,2,...,n},
// so that b[complement(a,b.length)] yields the complement of b[a].
#line 2412 "runtime.in"
// intarray* complement(intarray *a, int n);
void gen268(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  intarray * a = vm::pop<intarray *>(Stack);
#line 2413 "runtime.in"
  size_t asize=checkArray(a);
  array *r=new array(0);
  bool *keep=new bool(n);
  for(int i=0; i < n; ++i) keep[i]=true;
  for(size_t i=0; i < asize; ++i) {
    int j=read<int>(a,i);
    if(j >= 0 && j < n) keep[j]=false;
  }
  for(int i=0; i < n; i++)
    if(keep[i]) r->push(i);
  
  delete[] keep;
  {Stack->push<intarray*>(r); return;}
}

// Generate the sequence {f_i : i=0,1,...n-1} given a function f and integer n
#line 2430 "runtime.in"
void arraySequence(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  callable * f = vm::pop<callable *>(Stack);
#line 2431 "runtime.in"
  if(n < 0) n=0;
  array *a=new array(n);
  for(int i=0; i < n; ++i) {
    Stack->push(i);
    f->call(Stack);
    (*a)[i]=pop(Stack);
  }
  {Stack->push<intarray*>(a); return;}
}

// Return the array {0,1,...n-1}
#line 2443 "runtime.in"
// intarray* sequence(int n);
void gen270(stack *Stack)
{
  int n = vm::pop<int>(Stack);
#line 2444 "runtime.in"
  if(n < 0) n=0;
  array *a=new array(n);
  for(int i=0; i < n; ++i) {
    (*a)[i]=i;
  }
  {Stack->push<intarray*>(a); return;}
}

// Apply a function to each element of an array
#line 2454 "runtime.in"
void arrayFunction(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
  callable * f = vm::pop<callable *>(Stack);
#line 2455 "runtime.in"
  size_t size=checkArray(a);
  array *b=new array(size);
  for(size_t i=0; i < size; ++i) {
    Stack->push((*a)[i]);
    f->call(Stack);
    (*b)[i]=pop(Stack);
  }
  {Stack->push<array*>(b); return;}
}

#line 2466 "runtime.in"
// bool all(boolarray *a);
void gen272(stack *Stack)
{
  boolarray * a = vm::pop<boolarray *>(Stack);
#line 2467 "runtime.in"
  size_t size=checkArray(a);
  bool c=true;
  for(size_t i=0; i < size; i++)
    if(!get<bool>((*a)[i])) {c=false; break;}
  {Stack->push<bool>(c); return;}
}

#line 2475 "runtime.in"
// boolarray* !(boolarray* a);
void gen273(stack *Stack)
{
  boolarray* a = vm::pop<boolarray*>(Stack);
#line 2476 "runtime.in"
  size_t size=checkArray(a);
  array *c=new array(size);
  for(size_t i=0; i < size; i++)
    (*c)[i]=!read<bool>(a,i);
  {Stack->push<boolarray*>(c); return;}
}

#line 2484 "runtime.in"
// int sum(boolarray *a);
void gen274(stack *Stack)
{
  boolarray * a = vm::pop<boolarray *>(Stack);
#line 2485 "runtime.in"
  size_t size=checkArray(a);
  int sum=0;
  for(size_t i=0; i < size; i++)
    sum += read<bool>(a,i) ? 1 : 0;
  {Stack->push<int>(sum); return;}
}

#line 2493 "runtime.in"
void arrayCopy(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2494 "runtime.in"
  {Stack->push<array*>(copyArray(a)); return;}
}

#line 2498 "runtime.in"
void arrayConcat(stack *Stack)
{
  array * b = vm::pop<array *>(Stack);
  array * a = vm::pop<array *>(Stack);
#line 2499 "runtime.in"
  size_t asize=checkArray(a);
  size_t bsize=checkArray(b);
  array *c=new array(asize+bsize);
  for(size_t i=0; i < asize; i++) 
    (*c)[i]=(*a)[i];
  for(size_t i=0; i < bsize; i++, asize++) 
    (*c)[asize]=(*b)[i];
  {Stack->push<array*>(c); return;}
}

#line 2510 "runtime.in"
void array2Copy(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2511 "runtime.in"
  {Stack->push<array*>(copyArray2(a)); return;}
}

#line 2515 "runtime.in"
void array2Transpose(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
#line 2516 "runtime.in"
  size_t asize=checkArray(a);
  array *c=new array(0);
  for(size_t i=0; i < asize; i++) {
    size_t ip=i+1;
    array *ai=read<array*>(a,i);
    size_t aisize=checkArray(ai);
    size_t csize=c->size();
    if(csize < aisize) {
      c->resize(aisize);
      for(size_t j=csize; j < aisize; j++) {
	(*c)[j]=new array(ip);
      }
    }
    for(size_t j=0; j < aisize; j++) {
    array *cj=read<array*>(c,j);
    if(cj->size() < ip) cj->resize(ip);
    (*cj)[i]=(*ai)[j];
    }
  }
  {Stack->push<array*>(c); return;}
}

// In a boolean array, find the index of the nth true value or -1 if not found
// If n is negative, search backwards.
#line 2541 "runtime.in"
// int find(boolarray *a, int n=1);
void gen279(stack *Stack)
{
  int n = vm::pop<int>(Stack,1);
  boolarray * a = vm::pop<boolarray *>(Stack);
#line 2542 "runtime.in"
  
  size_t size=checkArray(a);
  int j=-1;
  if(n > 0)
    for(size_t i=0; i < size; i++)
      if(read<bool>(a,i)) {
	n--; if(n == 0) {j=(int) i; break;}
      }
  if(n < 0)
    for(size_t i=size; i > 0;)
      if(read<bool>(a,--i)) {
	n++; if(n == 0) {j=(int) i; break;}
      }
  {Stack->push<int>(j); return;}
}

// construct vector obtained by replacing those elements of b for which the
// corresponding elements of a are false by the corresponding element of c.
#line 2561 "runtime.in"
void arrayConditional(stack *Stack)
{
  array * c = vm::pop<array *>(Stack);
  array * b = vm::pop<array *>(Stack);
  array * a = vm::pop<array *>(Stack);
#line 2562 "runtime.in"
  size_t size=checkArray(a);
  array *r=new array(size);
  if(b && c) {
    checkArrays(a,b);
    checkArrays(b,c);
    for(size_t i=0; i < size; i++)
      (*r)[i]=read<bool>(a,i) ? (*b)[i] : (*c)[i];
  } else {
    r->clear();
    if(b) {
      checkArrays(a,b);
      for(size_t i=0; i < size; i++)
        if(read<bool>(a,i)) r->push((*b)[i]);
    } else if(c) {
      checkArrays(a,c);
      for(size_t i=0; i < size; i++)
        if(!read<bool>(a,i)) r->push((*c)[i]);
    }
  }
  {Stack->push<array*>(r); return;}
}

// Solve the linear equation ax=b by Gauss-Jordan elimination, returning
// the solution x, where a is an n x n matrix and b is an n x m matrix.
// If b is omitted or nm=0, return the inverse of a.
// TODO: Use LU decomposition for linear solve and specialize this routine
// for computing matrix inverses only.
#line 2590 "runtime.in"
// realarray2* solve(realarray2 *a, realarray2 *b=NULL);
void gen281(stack *Stack)
{
  realarray2 * b = vm::pop<realarray2 *>(Stack,NULL);
  realarray2 * a = vm::pop<realarray2 *>(Stack);
#line 2591 "runtime.in"
  a=copyArray2(a);
  size_t n=a->size();
  size_t bsize=b ? b->size() : 0;
  
  for(size_t i=0; i < n; i++)
    if(read<array*>(a,i)->size() != n)
      error("matrix a must be square");
    
  size_t m;
  if(bsize) {
    b=copyArray2(b);
    if(bsize != n) error("Incommensurate matrices");
    m=read<array*>(b,0)->size();
    for(size_t i=0; i < n; i++)
      if(read<array*>(b,i)->size() != m)
	error("matrix b must be rectangular");
  } else m=0;
  
  solveAllocate(n,m);
  
  for(size_t i=0; i < n; i++)
    pivot[i]=0;

  const char *singular="Singular matrix";
  
  size_t col=0, row=0;
  // This is the main loop over the columns to be reduced.
  for(size_t i=0; i < n; i++) {
    real big=0.0;
    // This is the outer loop of the search for a pivot element.
    for(size_t j=0; j < n; j++) {
      array *aj=read<array*>(a,j);
      if(pivot[j] != 1) {
	for(size_t k=0; k < n; k++) {
	  if(pivot[k] == 0) {
	    real temp=fabs(read<real>(aj,k));
	    if(temp >= big) {
	      big=temp;
	      row=j;
	      col=k;
	    }
	  } else if(pivot[k] > 1) {
	    solveDeallocate();
	    error(singular);
	  }
	}
      }
    }
    ++(pivot[col]);
    
    // Interchange rows, if needed, to put the pivot element on the diagonal.
    array *acol=read<array*>(a,col);
    array *bcol=m ? read<array*>(b,col) : 0;
    if(row != col) {
      array *arow=read<array*>(a,row);
      for(size_t l=0; l < n; l++) {
	real temp=read<real>(arow,l);
	(*arow)[l]=read<real>(acol,l);
	(*acol)[l]=temp;
      }
      if(m) {
	array *brow=read<array*>(b,row);
	for(size_t l=0; l < m; l++) {
	  real temp=read<real>(brow,l);
	  (*brow)[l]=read<real>(bcol,l);
	  (*bcol)[l]=temp;
	}
      }
    }
    
    if(m == 0) {
      Row[i]=row; 
      Col[i]=col;
    }
    // Divide the pivot row by the pivot element.
    real denom=read<real>(acol,col);
    if(denom == 0.0) {
      solveDeallocate();
      error(singular);
    }
    real pivinv=1.0/denom;
    (*acol)[col]=1.0;
    for(size_t l=0; l < n; l++) 
      (*acol)[l]=read<real>(acol,l)*pivinv;
    for(size_t l=0; l < m; l++)
      (*bcol)[l]=read<real>(bcol,l)*pivinv;
    
    // Reduce all rows except for the pivoted one.
    for(size_t k=0; k < n; k++) {
      if(k != col) { 
	array *ak=read<array*>(a,k);
	real dum=read<real>(ak,col);
	(*ak)[col]=0.0;
	for(size_t l=0; l < n; l++)
	  (*ak)[l]=read<real>(ak,l)-read<real>(acol,l)*dum;
	array *bk=m ? read<array*>(b,k) : 0;
	for(size_t l=0; l < m; l++)
	  (*bk)[l]=read<real>(bk,l)-read<real>(bcol,l)*dum;
      }
    }
  }
  
  if(m == 0) {
    // Unscramble the inverse matrix in view of the column interchanges.
    for(size_t l=n; l > 0;) {
      l--;
      size_t r=Row[l];
      size_t c=Col[l];
      if(r != c) {
	for(size_t k=0; k < n; k++) {
	  array *ak=read<array*>(a,k);
	  real temp=read<real>(ak,r);
	  (*ak)[r]=read<real>(ak,c);
	  (*ak)[c]=temp;
	}
      }
    }
    b=a;
  }
  solveDeallocate();
  {Stack->push<realarray2*>(b); return;}
}

// Solve the problem L\inv f, where f is an n vector and L is the n x n matrix
//
// [ b[0] c[0]           a[0]   ]
// [ a[1] b[1] c[1]             ]
// [      a[2] b[2] c[2]        ]
// [                ...         ]
// [       c[n-1] a[n-1] b[n-1] ]
#line 2722 "runtime.in"
// realarray* tridiagonal(realarray *a, realarray *b, realarray *c, realarray *f);
void gen282(stack *Stack)
{
  realarray * f = vm::pop<realarray *>(Stack);
  realarray * c = vm::pop<realarray *>(Stack);
  realarray * b = vm::pop<realarray *>(Stack);
  realarray * a = vm::pop<realarray *>(Stack);
#line 2723 "runtime.in"
  size_t n=checkArrays(a,b);
  if(n != checkArray(c) || n != checkArray(f))
    vm::error(arraymismatch);
  
  array *up=new array(n);
  array& u=*up;

  if(n == 0) {Stack->push<realarray*>(up); return;}
  
  // Special case: zero Dirichlet boundary conditions
  if(read<real>(a,0) == 0.0 && read<real>(c,n-1) == 0.0) {
    real temp=read<real>(b,0);
    if(temp == 0.0) dividebyzero();
    temp=1.0/temp;
    
    real *work=new real[n];
    u[0]=read<real>(f,0)*temp;
    work[0]=-read<real>(c,0)*temp;
	
    for(size_t i=1; i < n; i++) {
      real temp=(read<real>(b,i)+read<real>(a,i)*work[i-1]);
      if(temp == 0.0) {delete[] work; dividebyzero();}
      temp=1.0/temp;
      u[i]=(read<real>(f,i)-read<real>(a,i)*read<real>(u,i-1))*temp;
      work[i]=-read<real>(c,i)*temp;
    }

    for(size_t i=n-1; i >= 1; i--)
      u[i-1]=read<real>(u,i-1)+work[i-1]*read<real>(u,i);
    
    delete[] work;
    {Stack->push<realarray*>(up); return;}
  }
  
  real binv=read<real>(b,0);
  if(binv == 0.0) dividebyzero();
  binv=1.0/binv;
  
  if(n == 1) {u[0]=read<real>(f,0)*binv; {Stack->push<realarray*>(up); return;}}
  if(n == 2) {
    real factor=(read<real>(b,0)*read<real>(b,1)-
		   read<real>(a,0)*read<real>(c,1));
    if(factor== 0.0) dividebyzero();
    factor=1.0/factor;
    real temp=(read<real>(b,0)*read<real>(f,1)-
	  read<real>(c,1)*read<real>(f,0))*factor;
    u[0]=(read<real>(b,1)*read<real>(f,0)-
	  read<real>(a,0)*read<real>(f,1))*factor;
    u[1]=temp;
    {Stack->push<realarray*>(up); return;}
  }
	
  real *gamma=new real[n-2];
  real *delta=new real[n-2];
  
  gamma[0]=read<real>(c,0)*binv;
  delta[0]=read<real>(a,0)*binv;
  u[0]=read<real>(f,0)*binv;
  real beta=read<real>(c,n-1);
  real fn=read<real>(f,n-1)-beta*read<real>(u,0);
  real alpha=read<real>(b,n-1)-beta*delta[0];

  for(size_t i=1; i <= n-3; i++) {
    real alphainv=read<real>(b,i)-read<real>(a,i)*gamma[i-1];
    if(alphainv == 0.0) {delete[] gamma; delete[] delta; dividebyzero();}
    alphainv=1.0/alphainv;
    beta *= -gamma[i-1];
    gamma[i]=read<real>(c,i)*alphainv;
    u[i]=(read<real>(f,i)-read<real>(a,i)*read<real>(u,i-1))*alphainv;
    fn -= beta*read<real>(u,i);
    delta[i]=-read<real>(a,i)*delta[i-1]*alphainv;
    alpha -= beta*delta[i];
  }
	
  real alphainv=read<real>(b,n-2)-read<real>(a,n-2)*gamma[n-3];
  if(alphainv == 0.0) {delete[] gamma; delete[] delta; dividebyzero();}
  alphainv=1.0/alphainv;
  u[n-2]=(read<real>(f,n-2)-read<real>(a,n-2)*read<real>(u,n-3))
    *alphainv;
  beta=read<real>(a,n-1)-beta*gamma[n-3];
  real dnm1=(read<real>(c,n-2)-read<real>(a,n-2)*delta[n-3])*alphainv;
  real temp=alpha-beta*dnm1;
  if(temp == 0.0) {delete[] gamma; delete[] delta; dividebyzero();}
  u[n-1]=temp=(fn-beta*read<real>(u,n-2))/temp;
  u[n-2]=read<real>(u,n-2)-dnm1*temp;
	
  for(size_t i=n-2; i >= 1; i--)
    u[i-1]=read<real>(u,i-1)-gamma[i-1]*read<real>(u,i)-delta[i-1]*temp;
  
  delete[] gamma;
  delete[] delta;
  
  {Stack->push<realarray*>(up); return;}
}

// Compute the fast Fourier transform of a pair array
#line 2820 "runtime.in"
void pairArrayFFT(stack *Stack)
{
  int sign = vm::pop<int>(Stack,1);
  pairarray * a = vm::pop<pairarray *>(Stack);
#line 2821 "runtime.in"
  unsigned n=(unsigned) checkArray(a);
  array *c=new array(n);
#ifdef HAVE_LIBFFTW3
  Complex *f=FFTWComplex(n);
  fft1d Forward(n,sign,f);
  
  for(size_t i=0; i < n; i++) {
    pair z=read<pair>(a,i);
    f[i]=Complex(z.getx(),z.gety());
  }
  Forward.fft(f);
  
  for(size_t i=0; i < n; i++) {
    Complex z=f[i];
    (*c)[i]=pair(z.real(),z.imag());
  }
  FFTWdelete(f);
#else
  assert(sign); // Avoid unused variable warning message
#endif //  HAVE_LIBFFTW3
  {Stack->push<pairarray*>(c); return;}
}


// File operations
#line 2847 "runtime.in"
// bool ==(file *a, file *b);
void gen284(stack *Stack)
{
  file * b = vm::pop<file *>(Stack);
  file * a = vm::pop<file *>(Stack);
#line 2848 "runtime.in"
  {Stack->push<bool>(a == b); return;}
}

#line 2853 "runtime.in"
// bool !=(file *a, file *b);
void gen285(stack *Stack)
{
  file * b = vm::pop<file *>(Stack);
  file * a = vm::pop<file *>(Stack);
#line 2854 "runtime.in"
  {Stack->push<bool>(a != b); return;}
}

#line 2858 "runtime.in"
void standardOut(stack *Stack)
{
#line 2859 "runtime.in"
  {Stack->push<file*>(&camp::Stdout); return;}
}

#line 2863 "runtime.in"
void nullFile(stack *Stack)
{
#line 2864 "runtime.in"
  {Stack->push<file*>(&camp::nullfile); return;}
}

#line 2868 "runtime.in"
// file* input(string name, bool check=true, string comment=commentchar);
void gen288(stack *Stack)
{
  string comment = vm::pop<string>(Stack,commentchar);
  bool check = vm::pop<bool>(Stack,true);
  string name = vm::pop<string>(Stack);
#line 2869 "runtime.in"
  char c=comment == "" ? (char) 0 : comment[0];
  file *f=new ifile(name,check,c);
  f->open();
  {Stack->push<file*>(f); return;}
}

#line 2876 "runtime.in"
// file* output(string name, bool append=false);
void gen289(stack *Stack)
{
  bool append = vm::pop<bool>(Stack,false);
  string name = vm::pop<string>(Stack);
#line 2877 "runtime.in"
  file *f=new ofile(name,append);
  f->open();
  {Stack->push<file*>(f); return;}
}

#line 2883 "runtime.in"
// file* xinput(string name, bool check=true);
void gen290(stack *Stack)
{
  bool check = vm::pop<bool>(Stack,true);
  string name = vm::pop<string>(Stack);
#line 2884 "runtime.in"
#ifdef HAVE_RPC_RPC_H
  file *f=new ixfile(name,check);
  {Stack->push<file*>(f); return;}
#else  
  ostringstream buf;
  buf << name << ": XDR read support not enabled";
  error(buf);
  if(check) return; // Never reached; suppress unused variable warning
#endif
}

#line 2896 "runtime.in"
// file* xoutput(string name, bool append=false);
void gen291(stack *Stack)
{
  bool append = vm::pop<bool>(Stack,false);
  string name = vm::pop<string>(Stack);
#line 2897 "runtime.in"
#ifdef HAVE_RPC_RPC_H
  file *f=new oxfile(name,append);
  {Stack->push<file*>(f); return;}
#else  
  ostringstream buf;
  buf << name << ": XDR write support not enabled";
  error(buf);
  if(append) return; // Never reached; suppress unused variable warning
#endif
}

#line 2909 "runtime.in"
// bool eof(file *File);
void gen292(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 2910 "runtime.in"
  {Stack->push<bool>(File->eof()); return;}
}

#line 2914 "runtime.in"
// bool eol(file *File);
void gen293(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 2915 "runtime.in"
  {Stack->push<bool>(File->eol()); return;}
}

#line 2919 "runtime.in"
// bool error(file *File);
void gen294(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 2920 "runtime.in"
  {Stack->push<bool>(File->error()); return;}
}

#line 2924 "runtime.in"
// void clear(file *File);
void gen295(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 2925 "runtime.in"
  File->clear();
}

#line 2929 "runtime.in"
// void close(file *File);
void gen296(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 2930 "runtime.in"
  File->close();
}

#line 2934 "runtime.in"
// void precision(file *File, int digits);
void gen297(stack *Stack)
{
  int digits = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);
#line 2935 "runtime.in"
  File->precision(digits);
}

#line 2939 "runtime.in"
// void flush(file *File);
void gen298(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 2940 "runtime.in"
   File->flush();
}

#line 2944 "runtime.in"
// string getc(file *File);
void gen299(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 2945 "runtime.in"
  char c;
  if(File->isOpen()) File->read(c);
  static char str[1];
  str[0]=c;
  {Stack->push<string>(string(str)); return;}
}

#line 2953 "runtime.in"
// int tell(file *File);
void gen300(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 2954 "runtime.in"
  {Stack->push<int>((int) File->tell()); return;}
}

#line 2958 "runtime.in"
// void seek(file *File, int pos);
void gen301(stack *Stack)
{
  int pos = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);
#line 2959 "runtime.in"
  File->seek(pos);
}

// Set file dimensions
#line 2964 "runtime.in"
// file* dimension(file *File, int nx);
void gen302(stack *Stack)
{
  int nx = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);
#line 2965 "runtime.in"
  File->dimension(nx);
  {Stack->push<file*>(File); return;}
}

#line 2970 "runtime.in"
// file* dimension(file *File, int nx, int ny);
void gen303(stack *Stack)
{
  int ny = vm::pop<int>(Stack);
  int nx = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);
#line 2971 "runtime.in"
  File->dimension(nx,ny);
  {Stack->push<file*>(File); return;}
}

#line 2976 "runtime.in"
// file* dimension(file *File, int nx, int ny, int nz);
void gen304(stack *Stack)
{
  int nz = vm::pop<int>(Stack);
  int ny = vm::pop<int>(Stack);
  int nx = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);
#line 2977 "runtime.in"
  File->dimension(nx,ny,nz);
  {Stack->push<file*>(File); return;}
}

// Set file to read comma-separated values
#line 2983 "runtime.in"
// file* csv(file *File, bool b=true);
void gen305(stack *Stack)
{
  bool b = vm::pop<bool>(Stack,true);
  file * File = vm::pop<file *>(Stack);
#line 2984 "runtime.in"
  File->CSVMode(b);
  {Stack->push<file*>(File); return;}
}

// Set file to read arrays in line-at-a-time mode
#line 2990 "runtime.in"
// file* line(file *File, bool b=true);
void gen306(stack *Stack)
{
  bool b = vm::pop<bool>(Stack,true);
  file * File = vm::pop<file *>(Stack);
#line 2991 "runtime.in"
  File->LineMode(b);
  {Stack->push<file*>(File); return;}
}

// Set file to read/write single-precision XDR values.
#line 2997 "runtime.in"
// file* single(file *File, bool b=true);
void gen307(stack *Stack)
{
  bool b = vm::pop<bool>(Stack,true);
  file * File = vm::pop<file *>(Stack);
#line 2998 "runtime.in"
  File->SingleMode(b);
  {Stack->push<file*>(File); return;}
}

// Set file to read an array1 (1 int size followed by a 1d array)
#line 3004 "runtime.in"
// file* read1(file *File);
void gen308(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 3005 "runtime.in"
  File->dimension(-2);
  {Stack->push<file*>(File); return;}
}

// Set file to read an array2 (2 int sizes followed by a 2d array)
#line 3011 "runtime.in"
// file* read2(file *File);
void gen309(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 3012 "runtime.in"
  File->dimension(-2,-2);
  {Stack->push<file*>(File); return;}
}

// Set file to read an array3 (3 int sizes followed by a 3d array)
#line 3018 "runtime.in"
// file* read3(file *File);
void gen310(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);
#line 3019 "runtime.in"
  File->dimension(-2,-2,-2);
  {Stack->push<file*>(File); return;}
}

// Prompt for a string using the GNU readline library and a local history.
// On exit, save this local history under the name historyfilename(history),
// unless history begins with an underscore character.
#line 3027 "runtime.in"
// string readline(string prompt=emptystring, string history=emptystring,		string initial=emptystring, bool tabcompletion=false);
void gen311(stack *Stack)
{
  bool tabcompletion = vm::pop<bool>(Stack,false);
  string initial = vm::pop<string>(Stack,emptystring);
  string history = vm::pop<string>(Stack,emptystring);
  string prompt = vm::pop<string>(Stack,emptystring);
#line 3029 "runtime.in"
#if defined(HAVE_LIBREADLINE) && defined(HAVE_HISTORY_STATE) && \
    defined(HAVE_LIBCURSES)
  init_readline(tabcompletion);
  
  store_history(&history_save);
  bool newhistory=historyMap.find(history) == historyMap.end();
  HISTORY_STATE& History=historyMap[history];
  history_set_history_state(&History);
  if(history[0] != nosave && newhistory)
    read_history(historyfilename(history).c_str());
  
  static char *line_read=NULL;
  /* Return the memory to the free pool
     if the buffer has already been allocated. */
  if(line_read) {
    free(line_read);
    line_read=NULL;
  }
     
  HIST_ENTRY *last=history_get(history_length);
  const char *Default=last ? last->line : initial.c_str();
  int size=snprintf(NULL,0,prompt.c_str(),Default)+1;
  if(size < 1) size=255; // Workaround for non-C99 compliant systems.
  char *buf=new char[size];
  snprintf(buf,size,prompt.c_str(),Default);
  
  /* Get a line from the user. */
  line_read=readline(buf);
  delete[] buf;
     
  if(line_read) {
  /* If the line has any text in it, save it on the history. */
    if(*line_read) add_history(line_read);
  } else cout << endl;
  
  store_history(&History);
  history_set_history_state(&history_save);
  
  {Stack->push<string>(line_read ? string(*line_read ? line_read : Default) : emptystring); return;}
#else
  Stdout.write(prompt);
  static ifile Stdin("");
  string s;
  Stdin.read(s);
  if(tabcompletion) {Stack->push<string>(s); return;} // Avoid unused variable warning message.
  {Stack->push<string>(s); return;}
#endif
}

} // namespace run

namespace trans {

void gen_base_venv(venv &ve)
{
#line 548 "runtime.in"
  addFunc(ve, run::gen8, primBoolean(), "!", formal(primBoolean(), "b", false, false));
#line 602 "runtime.in"
  addFunc(ve, run::gen17, primBoolean(), "empty", formal(primPicture(), "f", false, false));
#line 607 "runtime.in"
  addFunc(ve, run::gen18, primPair(), "max", formal(primPicture(), "f", false, false));
#line 612 "runtime.in"
  addFunc(ve, run::gen19, primPair(), "min", formal(primPicture(), "f", false, false));
#line 617 "runtime.in"
  addFunc(ve, run::gen20, primVoid(), "label", formal(primPicture(), "f", false, false), formal(primString(), "s", false, false), formal(primString(), "size", false, false), formal(primReal(), "angle", false, false), formal(primPair(), "position", false, false), formal(primPair(), "align", false, false), formal(primPair(), "scale", false, false), formal(primPen(), "p", false, false));
#line 623 "runtime.in"
  addFunc(ve, run::gen21, primBoolean(), "labels", formal(primPicture(), "f", false, false));
#line 628 "runtime.in"
  addFunc(ve, run::gen22, primVoid(), "fill", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "p", false, false));
#line 633 "runtime.in"
  addFunc(ve, run::gen23, primVoid(), "latticeshade", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "fillrule", false, false), formal(penArray2()  , "p", false, false));
#line 638 "runtime.in"
  addFunc(ve, run::gen24, primVoid(), "axialshade", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "pena", false, false), formal(primPair(), "a", false, false), formal(primPen(), "penb", false, false), formal(primPair(), "b", false, false));
#line 643 "runtime.in"
  addFunc(ve, run::gen25, primVoid(), "radialshade", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "pena", false, false), formal(primPair(), "a", false, false), formal(primReal(), "ra", false, false), formal(primPen(), "penb", false, false), formal(primPair(), "b", false, false), formal(primReal(), "rb", false, false));
#line 649 "runtime.in"
  addFunc(ve, run::gen26, primVoid(), "gouraudshade", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "fillrule", false, false), formal(penArray()  , "p", false, false), formal(pairArray(), "z", false, false), formal(intArray(), "edges", false, false));
#line 658 "runtime.in"
  addFunc(ve, run::gen27, primVoid(), "clip", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "p", false, false));
#line 665 "runtime.in"
  addFunc(ve, run::gen28, primVoid(), "beginclip", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "p", false, false));
#line 670 "runtime.in"
  addFunc(ve, run::gen29, primVoid(), "postscript", formal(primPicture(), "f", false, false), formal(primString() , "s", false, false));
#line 675 "runtime.in"
  addFunc(ve, run::gen30, primVoid(), "tex", formal(primPicture(), "f", false, false), formal(primString() , "s", false, false));
#line 680 "runtime.in"
  addFunc(ve, run::gen31, primVoid(), "texpreamble", formal(primString() , "s", false, false));
#line 687 "runtime.in"
  addFunc(ve, run::gen32, primVoid(), "texreset");
#line 692 "runtime.in"
  addFunc(ve, run::gen33, primVoid(), "layer", formal(primPicture(), "f", false, false));
#line 697 "runtime.in"
  addFunc(ve, run::gen34, primVoid(), "image", formal(primPicture(), "f", false, false), formal(realArray2(), "data", false, false), formal(penArray()  , "palette", false, false), formal(primPair(), "initial", false, false), formal(primPair(), "final", false, false), formal(primTransform(), "t", true, false));
#line 704 "runtime.in"
  addFunc(ve, run::gen35, primVoid(), "shipout", formal(primString() , "prefix", true, false), formal(primPicture(), "f", false, false), formal(primPicture(), "preamble", true, false), formal(primString() , "format", true, false), formal(primBoolean(), "wait", true, false), formal(primBoolean(), "quiet", true, false), formal(transformArray(), "guitransform", false, false), formal(boolArray(), "guidelete", false, false));
#line 774 "runtime.in"
  addFunc(ve, run::gen37, primBoolean(), "==", formal(primPen(), "a", false, false), formal(primPen(), "b", false, false));
#line 779 "runtime.in"
  addFunc(ve, run::gen38, primBoolean(), "!=", formal(primPen(), "a", false, false), formal(primPen(), "b", false, false));
#line 784 "runtime.in"
  addFunc(ve, run::gen39, primPen(), "+", formal(primPen(), "a", false, false), formal(primPen(), "b", false, false));
#line 789 "runtime.in"
  addFunc(ve, run::gen40, primPen(), "*", formal(primReal(), "a", false, false), formal(primPen(), "b", false, false));
#line 794 "runtime.in"
  addFunc(ve, run::gen41, primPen(), "*", formal(primPen(), "a", false, false), formal(primReal(), "b", false, false));
#line 799 "runtime.in"
  addFunc(ve, run::gen42, primPair(), "max", formal(primPen(), "p", false, false));
#line 804 "runtime.in"
  addFunc(ve, run::gen43, primPair(), "min", formal(primPen(), "p", false, false));
#line 809 "runtime.in"
  addFunc(ve, run::gen44, primVoid(), "resetdefaultpen");
#line 815 "runtime.in"
  addFunc(ve, run::gen45, primVoid(), "defaultpen", formal(primPen(), "p", false, false));
#line 820 "runtime.in"
  addFunc(ve, run::gen46, primPen(), "defaultpen");
#line 825 "runtime.in"
  addFunc(ve, run::gen47, primPen(), "invisible");
#line 830 "runtime.in"
  addFunc(ve, run::gen48, primPen(), "gray", formal(primPen(), "p", false, false));
#line 837 "runtime.in"
  addFunc(ve, run::gen49, primPen(), "rgb", formal(primPen(), "p", false, false));
#line 844 "runtime.in"
  addFunc(ve, run::gen50, primPen(), "rgb", formal(primReal(), "r", false, false), formal(primReal(), "g", false, false), formal(primReal(), "b", false, false));
#line 849 "runtime.in"
  addFunc(ve, run::gen51, primPen(), "cmyk", formal(primReal(), "c", false, false), formal(primReal(), "m", false, false), formal(primReal(), "y", false, false), formal(primReal(), "k", false, false));
#line 854 "runtime.in"
  addFunc(ve, run::gen52, primPen(), "gray", formal(primReal(), "gray", false, false));
#line 859 "runtime.in"
  addFunc(ve, run::gen53, realArray(), "colors", formal(primPen(), "p", false, false));
#line 887 "runtime.in"
  addFunc(ve, run::gen54, primPen(), "pattern", formal(primString(), "s", false, false));
#line 892 "runtime.in"
  addFunc(ve, run::gen55, primString() , "pattern", formal(primPen(), "p", false, false));
#line 897 "runtime.in"
  addFunc(ve, run::gen56, primPen(), "fillrule", formal(primInt(), "n", false, false));
#line 902 "runtime.in"
  addFunc(ve, run::gen57, primInt(), "fillrule", formal(primPen(), "p", false, false));
#line 907 "runtime.in"
  addFunc(ve, run::gen58, primPen(), "linetype", formal(primString(), "s", false, false), formal(primReal(), "offset", true, false), formal(primBoolean(), "scale", true, false), formal(primBoolean(), "adjust", true, false));
#line 912 "runtime.in"
  addFunc(ve, run::gen59, primString() , "linetype", formal(primPen(), "p", false, false));
#line 917 "runtime.in"
  addFunc(ve, run::gen60, primPen(), "linecap", formal(primInt(), "n", false, false));
#line 922 "runtime.in"
  addFunc(ve, run::gen61, primInt(), "linecap", formal(primPen(), "p", false, false));
#line 927 "runtime.in"
  addFunc(ve, run::gen62, primPen(), "linejoin", formal(primInt(), "n", false, false));
#line 932 "runtime.in"
  addFunc(ve, run::gen63, primInt(), "linejoin", formal(primPen(), "p", false, false));
#line 937 "runtime.in"
  addFunc(ve, run::gen64, primPen(), "linewidth", formal(primReal(), "x", false, false));
#line 942 "runtime.in"
  addFunc(ve, run::gen65, primReal(), "linewidth", formal(primPen(), "p", false, false));
#line 947 "runtime.in"
  addFunc(ve, run::gen66, primPen(), "fontcommand", formal(primString(), "s", false, false));
#line 952 "runtime.in"
  addFunc(ve, run::gen67, primString() , "font", formal(primPen(), "p", false, false));
#line 957 "runtime.in"
  addFunc(ve, run::gen68, primPen(), "fontsize", formal(primReal(), "size", false, false), formal(primReal(), "lineskip", false, false));
#line 963 "runtime.in"
  addFunc(ve, run::gen69, primReal(), "fontsize", formal(primPen(), "p", false, false));
#line 968 "runtime.in"
  addFunc(ve, run::gen70, primReal(), "lineskip", formal(primPen(), "p", false, false));
#line 973 "runtime.in"
  addFunc(ve, run::gen71, primPen(), "overwrite", formal(primInt(), "n", false, false));
#line 979 "runtime.in"
  addFunc(ve, run::gen72, primInt(), "overwrite", formal(primPen(), "p", false, false));
#line 984 "runtime.in"
  addFunc(ve, run::gen73, primPen(), "basealign", formal(primInt(), "n", false, false));
#line 989 "runtime.in"
  addFunc(ve, run::gen74, primInt(), "basealign", formal(primPen(), "p", false, false));
#line 994 "runtime.in"
  addFunc(ve, run::gen75, primPath(), "nib", formal(primPen(), "p", false, false));
#line 1001 "runtime.in"
  addFunc(ve, run::gen76, primPen(), "makepen", formal(primPath(), "p", false, false));
#line 1006 "runtime.in"
  addFunc(ve, run::gen77, primVoid(), "_draw", formal(primPicture(), "f", false, false), formal(primPath(), "g", false, false), formal(primPen(), "p", false, false));
#line 1011 "runtime.in"
  addFunc(ve, run::gen78, primVoid(), "endclip", formal(primPicture(), "f", false, false));
#line 1016 "runtime.in"
  addFunc(ve, run::gen79, primVoid(), "gsave", formal(primPicture(), "f", false, false));
#line 1021 "runtime.in"
  addFunc(ve, run::gen80, primVoid(), "grestore", formal(primPicture(), "f", false, false));
#line 1026 "runtime.in"
  addFunc(ve, run::gen81, primVoid(), "begingroup", formal(primPicture(), "f", false, false));
#line 1031 "runtime.in"
  addFunc(ve, run::gen82, primVoid(), "endgroup", formal(primPicture(), "f", false, false));
#line 1036 "runtime.in"
  addFunc(ve, run::gen83, primVoid(), "add", formal(primPicture(), "dest", false, false), formal(primPicture(), "src", false, false));
#line 1041 "runtime.in"
  addFunc(ve, run::gen84, primVoid(), "prepend", formal(primPicture(), "dest", false, false), formal(primPicture(), "src", false, false));
#line 1046 "runtime.in"
  addFunc(ve, run::gen85, primBoolean(), "interact");
#line 1054 "runtime.in"
  addFunc(ve, run::gen86, primVoid(), "uptodate", formal(primBoolean(), "b", false, false));
#line 1059 "runtime.in"
  addFunc(ve, run::gen87, primBoolean(), "uptodate");
#line 1064 "runtime.in"
  addFunc(ve, run::gen88, primInt(), "system", formal(primString(), "str", false, false));
#line 1073 "runtime.in"
  addFunc(ve, run::gen89, primVoid(), "abort", formal(primString(), "msg", false, false));
#line 1078 "runtime.in"
  addFunc(ve, run::gen90, primVoid(), "assert", formal(primBoolean(), "b", false, false));
#line 1084 "runtime.in"
  addFunc(ve, run::gen91, primVoid(), "_eval", formal(primString(), "s", false, false), formal(primBoolean(), "embedded", false, false));
#line 1089 "runtime.in"
  addFunc(ve, run::gen92, primVoid(), "_eval", formal(primCode(), "s", false, false), formal(primBoolean(), "embedded", false, false));
#line 1094 "runtime.in"
  addFunc(ve, run::gen93, primVoid(), "gui", formal(primReal(), "x", true, false));
#line 1099 "runtime.in"
  addFunc(ve, run::gen94, primBoolean(), "deconstruct");
#line 1104 "runtime.in"
  addFunc(ve, run::gen95, primVoid(), "readGUI");
#line 1129 "runtime.in"
  addFunc(ve, run::gen97, primString() , "cd", formal(primString(), "d", false, false));
#line 1143 "runtime.in"
  addFunc(ve, run::gen98, primVoid(), "scroll", formal(primInt(), "n", false, false));
#line 1157 "runtime.in"
  addFunc(ve, run::gen100, primPair(), "point", formal(primPath(), "p", false, false), formal(primInt(), "n", false, false));
#line 1162 "runtime.in"
  addFunc(ve, run::gen101, primPair(), "point", formal(primPath(), "p", false, false), formal(primReal(), "t", false, false));
#line 1167 "runtime.in"
  addFunc(ve, run::gen102, primPair(), "precontrol", formal(primPath(), "p", false, false), formal(primInt(), "n", false, false));
#line 1172 "runtime.in"
  addFunc(ve, run::gen103, primPair(), "precontrol", formal(primPath(), "p", false, false), formal(primReal(), "t", false, false));
#line 1177 "runtime.in"
  addFunc(ve, run::gen104, primPair(), "postcontrol", formal(primPath(), "p", false, false), formal(primInt(), "n", false, false));
#line 1182 "runtime.in"
  addFunc(ve, run::gen105, primPair(), "postcontrol", formal(primPath(), "p", false, false), formal(primReal(), "t", false, false));
#line 1187 "runtime.in"
  addFunc(ve, run::gen106, primPair(), "dir", formal(primPath(), "p", false, false), formal(primInt(), "n", false, false));
#line 1192 "runtime.in"
  addFunc(ve, run::gen107, primPair(), "dir", formal(primPath(), "p", false, false), formal(primReal(), "t", false, false));
#line 1197 "runtime.in"
  addFunc(ve, run::gen108, primPath(), "reverse", formal(primPath(), "p", false, false));
#line 1202 "runtime.in"
  addFunc(ve, run::gen109, primPath(), "subpath", formal(primPath(), "p", false, false), formal(primInt(), "b", false, false), formal(primInt(), "e", false, false));
#line 1207 "runtime.in"
  addFunc(ve, run::gen110, primPath(), "subpath", formal(primPath(), "p", false, false), formal(primReal(), "b", false, false), formal(primReal(), "e", false, false));
#line 1212 "runtime.in"
  addFunc(ve, run::gen111, primInt(), "length", formal(primPath(), "p", false, false));
#line 1217 "runtime.in"
  addFunc(ve, run::gen112, primBoolean(), "cyclic", formal(primPath(), "p", false, false));
#line 1222 "runtime.in"
  addFunc(ve, run::gen113, primBoolean(), "straight", formal(primPath(), "p", false, false), formal(primInt(), "i", false, false));
#line 1227 "runtime.in"
  addFunc(ve, run::gen114, primReal(), "arclength", formal(primPath(), "p", false, false));
#line 1232 "runtime.in"
  addFunc(ve, run::gen115, primReal(), "arctime", formal(primPath(), "p", false, false), formal(primReal(), "dval", false, false));
#line 1237 "runtime.in"
  addFunc(ve, run::gen116, primReal(), "dirtime", formal(primPath(), "p", false, false), formal(primPair(), "z", false, false));
#line 1242 "runtime.in"
  addFunc(ve, run::gen117, primPair(), "intersect", formal(primPath(), "x", false, false), formal(primPath(), "y", false, false), formal(primReal(), "fuzz", true, false));
#line 1247 "runtime.in"
  addFunc(ve, run::gen118, primInt(), "size", formal(primPath(), "p", false, false));
#line 1252 "runtime.in"
  addFunc(ve, run::gen119, primPath(), "&", formal(primPath(), "p", false, false), formal(primPath(), "q", false, false));
#line 1257 "runtime.in"
  addFunc(ve, run::gen120, primPair(), "min", formal(primPath(), "p", false, false));
#line 1262 "runtime.in"
  addFunc(ve, run::gen121, primPair(), "max", formal(primPath(), "p", false, false));
#line 1267 "runtime.in"
  addFunc(ve, run::gen122, primReal(), "relativedistance", formal(primReal(), "theta", false, false), formal(primReal(), "phi", false, false), formal(primReal(), "t", false, false), formal(primBoolean(), "atleast", false, false));
#line 1272 "runtime.in"
  addFunc(ve, run::gen123, primBoolean(), "inside", formal(pathArray()  , "g", false, false), formal(primPair(), "z", false, false), formal(primPen(), "p", false, false));
#line 1327 "runtime.in"
  addFunc(ve, run::gen127, primGuide(), "operator cycle");
#line 1332 "runtime.in"
  addFunc(ve, run::gen128, primGuide(), "operator spec", formal(primPair(), "z", false, false), formal(primInt(), "p", false, false));
#line 1340 "runtime.in"
  addFunc(ve, run::gen129, primGuide(), "operator curl", formal(primReal(), "gamma", false, false), formal(primInt(), "p", false, false));
#line 1348 "runtime.in"
  addFunc(ve, run::gen130, primGuide(), "operator tension", formal(primReal(), "tout", false, false), formal(primReal(), "tin", false, false), formal(primBoolean(), "atleast", false, false));
#line 1353 "runtime.in"
  addFunc(ve, run::gen131, primGuide(), "operator controls", formal(primPair(), "zout", false, false), formal(primPair(), "zin", false, false));
#line 1366 "runtime.in"
  addFunc(ve, run::gen133, primInt(), "length", formal(primString(), "s", false, false));
#line 1371 "runtime.in"
  addFunc(ve, run::gen134, primInt(), "find", formal(primString(), "s", false, false), formal(primString() , "t", false, false), formal(primInt(), "pos", true, false));
#line 1376 "runtime.in"
  addFunc(ve, run::gen135, primInt(), "rfind", formal(primString(), "s", false, false), formal(primString() , "t", false, false), formal(primInt(), "pos", true, false));
#line 1381 "runtime.in"
  addFunc(ve, run::gen136, primString() , "reverse", formal(primString() , "s", false, false));
#line 1387 "runtime.in"
  addFunc(ve, run::gen137, primString() , "insert", formal(primString() , "s", false, false), formal(primInt(), "pos", false, false), formal(primString() , "t", false, false));
#line 1394 "runtime.in"
  addFunc(ve, run::gen138, primString() , "substr", formal(primString(), "s", false, false), formal(primInt(), "pos", false, false), formal(primInt(), "n", true, false));
#line 1401 "runtime.in"
  addFunc(ve, run::gen139, primString() , "erase", formal(primString() , "s", false, false), formal(primInt(), "pos", false, false), formal(primInt(), "n", false, false));
#line 1408 "runtime.in"
  addFunc(ve, run::gen140, primString() , "replace", formal(primString(), "s", false, false), formal(stringArray2(), "translate", false, false));
#line 1435 "runtime.in"
  addFunc(ve, run::gen141, primString() , "format", formal(primString(), "format", false, false), formal(primInt(), "x", false, false));
#line 1450 "runtime.in"
  addFunc(ve, run::gen142, primString() , "format", formal(primString(), "format", false, false), formal(primReal(), "x", false, false));
#line 1554 "runtime.in"
  addFunc(ve, run::gen143, primString() , "string", formal(primReal(), "x", false, false), formal(primInt(), "digits", false, false));
#line 1562 "runtime.in"
  addFunc(ve, run::gen144, primString() , "time", formal(primString(), "format", false, false));
#line 1575 "runtime.in"
  addFunc(ve, run::gen145, primReal(), "^", formal(primReal(), "x", false, false), formal(primInt(), "y", false, false));
#line 1583 "runtime.in"
  addFunc(ve, run::gen146, primInt(), "quotient", formal(primInt(), "x", false, false), formal(primInt(), "y", false, false));
#line 1590 "runtime.in"
  addFunc(ve, run::gen147, primInt(), "abs", formal(primInt(), "x", false, false));
#line 1595 "runtime.in"
  addFunc(ve, run::gen148, primInt(), "sgn", formal(primReal(), "x", false, false));
#line 1600 "runtime.in"
  addFunc(ve, run::gen149, primInt(), "rand");
#line 1605 "runtime.in"
  addFunc(ve, run::gen150, primVoid(), "srand", formal(primInt(), "seed", false, false));
#line 1610 "runtime.in"
  addFunc(ve, run::gen151, primInt(), "ceil", formal(primReal(), "x", false, false));
#line 1617 "runtime.in"
  addFunc(ve, run::gen152, primInt(), "floor", formal(primReal(), "x", false, false));
#line 1624 "runtime.in"
  addFunc(ve, run::gen153, primInt(), "round", formal(primReal(), "x", false, false));
#line 1630 "runtime.in"
  addFunc(ve, run::gen154, primInt(), "Ceil", formal(primReal(), "x", false, false));
#line 1635 "runtime.in"
  addFunc(ve, run::gen155, primInt(), "Floor", formal(primReal(), "x", false, false));
#line 1640 "runtime.in"
  addFunc(ve, run::gen156, primInt(), "Round", formal(primReal(), "x", false, false));
#line 1645 "runtime.in"
  addFunc(ve, run::gen157, primReal(), "fmod", formal(primReal(), "x", false, false), formal(primReal(), "y", false, false));
#line 1651 "runtime.in"
  addFunc(ve, run::gen158, primReal(), "atan2", formal(primReal(), "y", false, false), formal(primReal(), "x", false, false));
#line 1656 "runtime.in"
  addFunc(ve, run::gen159, primReal(), "hypot", formal(primReal(), "x", false, false), formal(primReal(), "y", false, false));
#line 1661 "runtime.in"
  addFunc(ve, run::gen160, primReal(), "remainder", formal(primReal(), "x", false, false), formal(primReal(), "y", false, false));
#line 1666 "runtime.in"
  addFunc(ve, run::gen161, primReal(), "J", formal(primInt(), "n", false, false), formal(primReal(), "x", false, false));
#line 1671 "runtime.in"
  addFunc(ve, run::gen162, primReal(), "Y", formal(primInt(), "n", false, false), formal(primReal(), "x", false, false));
#line 1676 "runtime.in"
  addFunc(ve, run::gen163, primReal(), "erf", formal(primReal(), "x", false, false));
#line 1681 "runtime.in"
  addFunc(ve, run::gen164, primReal(), "erfc", formal(primReal(), "x", false, false));
#line 1686 "runtime.in"
  addFunc(ve, run::gen165, primReal(), "gamma", formal(primReal(), "x", false, false));
#line 1696 "runtime.in"
  addFunc(ve, run::gen166, realArray(), "quadraticroots", formal(primReal(), "a", false, false), formal(primReal(), "b", false, false), formal(primReal(), "c", false, false));
#line 1705 "runtime.in"
  addFunc(ve, run::gen167, realArray(), "cubicroots", formal(primReal(), "a", false, false), formal(primReal(), "b", false, false), formal(primReal(), "c", false, false), formal(primReal(), "d", false, false));
#line 1715 "runtime.in"
  addFunc(ve, run::gen168, primBoolean(), "==", formal(primTransform(), "a", false, false), formal(primTransform(), "b", false, false));
#line 1723 "runtime.in"
  addFunc(ve, run::gen169, primBoolean(), "!=", formal(primTransform(), "a", false, false), formal(primTransform(), "b", false, false));
#line 1728 "runtime.in"
  addFunc(ve, run::gen170, primTransform(), "operator +", formal(primTransform(), "a", false, false), formal(primTransform(), "b", false, false));
#line 1733 "runtime.in"
  addFunc(ve, run::gen171, primTransform(), "*", formal(primTransform(), "a", false, false), formal(primTransform(), "b", false, false));
#line 1738 "runtime.in"
  addFunc(ve, run::gen172, primPair(), "*", formal(primTransform(), "t", false, false), formal(primPair(), "z", false, false));
#line 1743 "runtime.in"
  addFunc(ve, run::gen173, primPath(), "*", formal(primTransform(), "t", false, false), formal(primPath(), "g", false, false));
#line 1748 "runtime.in"
  addFunc(ve, run::gen174, primPen(), "*", formal(primTransform(), "t", false, false), formal(primPen(), "p", false, false));
#line 1753 "runtime.in"
  addFunc(ve, run::gen175, primPicture(), "*", formal(primTransform(), "t", false, false), formal(primPicture(), "f", false, false));
#line 1758 "runtime.in"
  addFunc(ve, run::gen176, primTransform(), "^", formal(primTransform(), "t", false, false), formal(primInt(), "n", false, false));
#line 1805 "runtime.in"
  addFunc(ve, run::gen184, primTransform(), "shift", formal(primTransform(), "t", false, false));
#line 1810 "runtime.in"
  addFunc(ve, run::gen185, primTransform(), "shiftless", formal(primTransform(), "t", false, false));
#line 1815 "runtime.in"
  addFunc(ve, run::transformIdentity, primTransform(), "identity");
#line 1820 "runtime.in"
  addFunc(ve, run::gen187, primTransform(), "inverse", formal(primTransform(), "t", false, false));
#line 1825 "runtime.in"
  addFunc(ve, run::gen188, primTransform(), "shift", formal(primPair(), "z", false, false));
#line 1830 "runtime.in"
  addFunc(ve, run::gen189, primTransform(), "shift", formal(primReal(), "x", false, false), formal(primReal(), "y", false, false));
#line 1835 "runtime.in"
  addFunc(ve, run::gen190, primTransform(), "xscale", formal(primReal(), "x", false, false));
#line 1840 "runtime.in"
  addFunc(ve, run::gen191, primTransform(), "yscale", formal(primReal(), "y", false, false));
#line 1845 "runtime.in"
  addFunc(ve, run::gen192, primTransform(), "scale", formal(primReal(), "x", false, false));
#line 1850 "runtime.in"
  addFunc(ve, run::gen193, primTransform(), "slant", formal(primReal(), "s", false, false));
#line 1855 "runtime.in"
  addFunc(ve, run::gen194, primTransform(), "rotate", formal(primReal(), "angle", false, false), formal(primPair(), "z", true, false));
#line 1860 "runtime.in"
  addFunc(ve, run::gen195, primTransform(), "reflect", formal(primPair(), "a", false, false), formal(primPair(), "b", false, false));
#line 1884 "runtime.in"
  addFunc(ve, run::pairXPart, primReal(), "xpart", formal(primPair(), "z", false, false));
#line 1889 "runtime.in"
  addFunc(ve, run::pairYPart, primReal(), "ypart", formal(primPair(), "z", false, false));
#line 1894 "runtime.in"
  addFunc(ve, run::gen201, primReal(), "length", formal(primPair(), "z", false, false));
#line 1899 "runtime.in"
  addFunc(ve, run::gen202, primReal(), "abs", formal(primPair(), "z", false, false));
#line 1904 "runtime.in"
  addFunc(ve, run::gen203, primReal(), "angle", formal(primPair(), "z", false, false), formal(primBoolean(), "warn", true, false));
#line 1911 "runtime.in"
  addFunc(ve, run::gen204, primReal(), "degrees", formal(primPair(), "z", false, false), formal(primBoolean(), "warn", true, false));
#line 1918 "runtime.in"
  addFunc(ve, run::gen205, primReal(), "radians", formal(primReal(), "degrees", false, false));
#line 1924 "runtime.in"
  addFunc(ve, run::gen206, primReal(), "degrees", formal(primReal(), "radians", false, false));
#line 1930 "runtime.in"
  addFunc(ve, run::gen207, primReal(), "Degrees", formal(primReal(), "radians", false, false));
#line 1936 "runtime.in"
  addFunc(ve, run::gen208, primReal(), "Sin", formal(primReal(), "deg", false, false));
#line 1941 "runtime.in"
  addFunc(ve, run::gen209, primReal(), "Cos", formal(primReal(), "deg", false, false));
#line 1946 "runtime.in"
  addFunc(ve, run::gen210, primReal(), "Tan", formal(primReal(), "deg", false, false));
#line 1951 "runtime.in"
  addFunc(ve, run::gen211, primReal(), "aSin", formal(primReal(), "x", false, false));
#line 1956 "runtime.in"
  addFunc(ve, run::gen212, primReal(), "aCos", formal(primReal(), "x", false, false));
#line 1961 "runtime.in"
  addFunc(ve, run::gen213, primReal(), "aTan", formal(primReal(), "x", false, false));
#line 1966 "runtime.in"
  addFunc(ve, run::gen214, primPair(), "unit", formal(primPair(), "z", false, false));
#line 1971 "runtime.in"
  addFunc(ve, run::gen215, primPair(), "dir", formal(primReal(), "theta", false, false));
#line 1976 "runtime.in"
  addFunc(ve, run::gen216, primPair(), "expi", formal(primReal(), "theta", false, false));
#line 1981 "runtime.in"
  addFunc(ve, run::gen217, primPair(), "conj", formal(primPair(), "z", false, false));
#line 1986 "runtime.in"
  addFunc(ve, run::gen218, primReal(), "dot", formal(primPair(), "u", false, true), formal(primPair(), "v", false, true));
#line 1992 "runtime.in"
  addFunc(ve, run::gen219, primPair(), "minbound", formal(primPair(), "z", false, false), formal(primPair(), "w", false, false));
#line 1997 "runtime.in"
  addFunc(ve, run::gen220, primPair(), "maxbound", formal(primPair(), "z", false, false), formal(primPair(), "w", false, false));
#line 2017 "runtime.in"
  addFunc(ve, run::tripleXPart, primReal(), "xpart", formal(primTriple(), "v", false, false));
#line 2022 "runtime.in"
  addFunc(ve, run::tripleYPart, primReal(), "ypart", formal(primTriple(), "v", false, false));
#line 2027 "runtime.in"
  addFunc(ve, run::tripleZPart, primReal(), "zpart", formal(primTriple(), "v", false, false));
#line 2032 "runtime.in"
  addFunc(ve, run::gen226, primTriple(), "*", formal(primReal(), "x", false, false), formal(primTriple(), "v", false, false));
#line 2037 "runtime.in"
  addFunc(ve, run::gen227, primTriple(), "*", formal(primTriple(), "v", false, false), formal(primReal(), "x", false, false));
#line 2042 "runtime.in"
  addFunc(ve, run::gen228, primTriple(), "/", formal(primTriple(), "v", false, false), formal(primReal(), "x", false, false));
#line 2047 "runtime.in"
  addFunc(ve, run::gen229, primReal(), "length", formal(primTriple(), "v", false, false));
#line 2052 "runtime.in"
  addFunc(ve, run::gen230, primReal(), "abs", formal(primTriple(), "v", false, false));
#line 2057 "runtime.in"
  addFunc(ve, run::gen231, primReal(), "polar", formal(primTriple(), "v", false, false));
#line 2062 "runtime.in"
  addFunc(ve, run::gen232, primReal(), "azimuth", formal(primTriple(), "v", false, false));
#line 2067 "runtime.in"
  addFunc(ve, run::gen233, primReal(), "colatitude", formal(primTriple(), "v", false, false));
#line 2072 "runtime.in"
  addFunc(ve, run::gen234, primReal(), "latitude", formal(primTriple(), "v", false, false));
#line 2077 "runtime.in"
  addFunc(ve, run::gen235, primReal(), "longitude", formal(primTriple(), "v", false, false), formal(primBoolean(), "warn", true, false));
#line 2084 "runtime.in"
  addFunc(ve, run::gen236, primTriple(), "unit", formal(primTriple(), "v", false, false));
#line 2089 "runtime.in"
  addFunc(ve, run::gen237, primReal(), "dot", formal(primTriple(), "u", false, false), formal(primTriple(), "v", false, false));
#line 2094 "runtime.in"
  addFunc(ve, run::gen238, primTriple(), "cross", formal(primTriple(), "u", false, false), formal(primTriple(), "v", false, false));
#line 2101 "runtime.in"
  addFunc(ve, run::gen239, primTriple(), "expi", formal(primReal(), "theta", false, false), formal(primReal(), "phi", false, false));
#line 2108 "runtime.in"
  addFunc(ve, run::gen240, primTriple(), "dir", formal(primReal(), "theta", false, false), formal(primReal(), "phi", false, false));
#line 2113 "runtime.in"
  addFunc(ve, run::gen241, primTriple(), "minbound", formal(primTriple(), "u", false, false), formal(primTriple(), "v", false, false));
#line 2119 "runtime.in"
  addFunc(ve, run::gen242, primTriple(), "maxbound", formal(primTriple(), "u", false, false), formal(primTriple(), "v", false, false));
#line 2125 "runtime.in"
  addFunc(ve, run::gen243, primReal(), "cubiclength", formal(primTriple(), "z0", false, false), formal(primTriple(), "z0p", false, false), formal(primTriple(), "z1m", false, false), formal(primTriple(), "z1", false, false), formal(primReal(), "goal", false, false));
#line 2130 "runtime.in"
  addFunc(ve, run::gen244, primPair(), "intersect", formal(tripleArray(), "pre1", false, false), formal(tripleArray(), "point1", false, false), formal(tripleArray(), "post1", false, false), formal(tripleArray(), "pre2", false, false), formal(tripleArray(), "point2", false, false), formal(tripleArray(), "post2", false, false), formal(primReal(), "fuzz", false, false));
#line 2163 "runtime.in"
  addFunc(ve, run::gen245, primString() , "VERSION");
#line 2171 "runtime.in"
  addFunc(ve, run::gen246, primVoid(), "atexit", formal(voidFunction(), "f", false, false));
#line 2176 "runtime.in"
  addFunc(ve, run::gen247, voidFunction(), "atexit");
#line 2181 "runtime.in"
  addFunc(ve, run::gen248, primInt(), "merge", formal(stringArray(), "files", false, false), formal(primString(), "args", false, false), formal(primString(), "format", false, false));
#line 2410 "runtime.in"
  addFunc(ve, run::gen268, intArray(), "complement", formal(intArray(), "a", false, false), formal(primInt(), "n", false, false));
#line 2442 "runtime.in"
  addFunc(ve, run::gen270, intArray(), "sequence", formal(primInt(), "n", false, false));
#line 2466 "runtime.in"
  addFunc(ve, run::gen272, primBoolean(), "all", formal(boolArray(), "a", false, false));
#line 2475 "runtime.in"
  addFunc(ve, run::gen273, boolArray(), "!", formal(boolArray(), "a", false, false));
#line 2484 "runtime.in"
  addFunc(ve, run::gen274, primInt(), "sum", formal(boolArray(), "a", false, false));
#line 2539 "runtime.in"
  addFunc(ve, run::gen279, primInt(), "find", formal(boolArray(), "a", false, false), formal(primInt(), "n", true, false));
#line 2585 "runtime.in"
  addFunc(ve, run::gen281, realArray2(), "solve", formal(realArray2(), "a", false, false), formal(realArray2(), "b", true, false));
#line 2715 "runtime.in"
  addFunc(ve, run::gen282, realArray(), "tridiagonal", formal(realArray(), "a", false, false), formal(realArray(), "b", false, false), formal(realArray(), "c", false, false), formal(realArray(), "f", false, false));
#line 2845 "runtime.in"
  addFunc(ve, run::gen284, primBoolean(), "==", formal(primFile(), "a", false, false), formal(primFile(), "b", false, false));
#line 2853 "runtime.in"
  addFunc(ve, run::gen285, primBoolean(), "!=", formal(primFile(), "a", false, false), formal(primFile(), "b", false, false));
#line 2868 "runtime.in"
  addFunc(ve, run::gen288, primFile(), "input", formal(primString() , "name", false, false), formal(primBoolean(), "check", true, false), formal(primString() , "comment", true, false));
#line 2876 "runtime.in"
  addFunc(ve, run::gen289, primFile(), "output", formal(primString() , "name", false, false), formal(primBoolean(), "append", true, false));
#line 2883 "runtime.in"
  addFunc(ve, run::gen290, primFile(), "xinput", formal(primString() , "name", false, false), formal(primBoolean(), "check", true, false));
#line 2896 "runtime.in"
  addFunc(ve, run::gen291, primFile(), "xoutput", formal(primString() , "name", false, false), formal(primBoolean(), "append", true, false));
#line 2909 "runtime.in"
  addFunc(ve, run::gen292, primBoolean(), "eof", formal(primFile(), "file", false, false));
#line 2914 "runtime.in"
  addFunc(ve, run::gen293, primBoolean(), "eol", formal(primFile(), "file", false, false));
#line 2919 "runtime.in"
  addFunc(ve, run::gen294, primBoolean(), "error", formal(primFile(), "file", false, false));
#line 2924 "runtime.in"
  addFunc(ve, run::gen295, primVoid(), "clear", formal(primFile(), "file", false, false));
#line 2929 "runtime.in"
  addFunc(ve, run::gen296, primVoid(), "close", formal(primFile(), "file", false, false));
#line 2934 "runtime.in"
  addFunc(ve, run::gen297, primVoid(), "precision", formal(primFile(), "file", false, false), formal(primInt(), "digits", false, false));
#line 2939 "runtime.in"
  addFunc(ve, run::gen298, primVoid(), "flush", formal(primFile(), "file", false, false));
#line 2944 "runtime.in"
  addFunc(ve, run::gen299, primString() , "getc", formal(primFile(), "file", false, false));
#line 2953 "runtime.in"
  addFunc(ve, run::gen300, primInt(), "tell", formal(primFile(), "file", false, false));
#line 2958 "runtime.in"
  addFunc(ve, run::gen301, primVoid(), "seek", formal(primFile(), "file", false, false), formal(primInt(), "pos", false, false));
#line 2963 "runtime.in"
  addFunc(ve, run::gen302, primFile(), "dimension", formal(primFile(), "file", false, false), formal(primInt(), "nx", false, false));
#line 2970 "runtime.in"
  addFunc(ve, run::gen303, primFile(), "dimension", formal(primFile(), "file", false, false), formal(primInt(), "nx", false, false), formal(primInt(), "ny", false, false));
#line 2976 "runtime.in"
  addFunc(ve, run::gen304, primFile(), "dimension", formal(primFile(), "file", false, false), formal(primInt(), "nx", false, false), formal(primInt(), "ny", false, false), formal(primInt(), "nz", false, false));
#line 2982 "runtime.in"
  addFunc(ve, run::gen305, primFile(), "csv", formal(primFile(), "file", false, false), formal(primBoolean(), "b", true, false));
#line 2989 "runtime.in"
  addFunc(ve, run::gen306, primFile(), "line", formal(primFile(), "file", false, false), formal(primBoolean(), "b", true, false));
#line 2996 "runtime.in"
  addFunc(ve, run::gen307, primFile(), "single", formal(primFile(), "file", false, false), formal(primBoolean(), "b", true, false));
#line 3003 "runtime.in"
  addFunc(ve, run::gen308, primFile(), "read1", formal(primFile(), "file", false, false));
#line 3010 "runtime.in"
  addFunc(ve, run::gen309, primFile(), "read2", formal(primFile(), "file", false, false));
#line 3017 "runtime.in"
  addFunc(ve, run::gen310, primFile(), "read3", formal(primFile(), "file", false, false));
#line 3024 "runtime.in"
  addFunc(ve, run::gen311, primString() , "readline", formal(primString() , "prompt", true, false), formal(primString() , "history", true, false), formal(primString() , "initial", true, false), formal(primBoolean(), "tabcompletion", true, false));
}

} // namespace trans
